# -------------------------------------------------------------------------------------------------
#<profile4xi profile = "11" />
#<program4xi program = "sampler4xi5test.py">
#<abstract4xi abstract = "tests sampler4xi.py"/>
#<verify4xi verification = "11" target = "sampler4xi5test.py"/>
#<contextualize4xi context = "sampler4xi.py"/>
#<use4xi usage = "
# SET:
# 
# RUN:
# > python sampler4xi5test.py > E:\scope4xi\041721\zap\work\txt\sampler4xi5test.txt
#
# ANALYZE:
#
# sense-test-sampler4xi5test.xml     <-- trace in XML
# reason-test-sampler4xi5test.xml
# ace-test-sampler4xi5test.xml
# sampler4xi5test.txt                <-- OF SAMPLER4XI5TEST
#"/>
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = "  
__all__ = ['sampler4xi5test'] 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

import signal
import itertools
import weakref
import logging  
#"
#/>


# -------------------------------------------------------------------------------------------------
# Scope4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/> 

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from pipe4xi import Pipe4Xi   
from platformids4xi import get2platformids4xi
from queue4xi import Queue4Xi

# -------------------------------------------------------------------------------------------------
# Command queue module                           
# -------------------------------------------------------------------------------------------------
from commandqueue4xi import CommandQueue4Xi
from commandqueue4xi import create2commandqueue4xi 
from commandqueue4xi import flush2commandqueue4xi
from commandqueue4xi import finish2commandqueue4xi
from commandqueue4xi import get2commandqueueinfo4xi
from commandqueue4xi import release2commandqueue4xi
from commandqueue4xi import retain2commandqueue4xi
from commandqueue4xi import set2commandqueue4xi


# -------------------------------------------------------------------------------------------------
# Context module                           
# -------------------------------------------------------------------------------------------------
from context4xi import Context4Xi 
from context4xi import create2context4xi
from context4xi import get2context4xi
from context4xi import release2context4xi
from context4xi import retain2context4xi
from context4xi import set2context4xi


# -------------------------------------------------------------------------------------------------
# Device module                        
# -------------------------------------------------------------------------------------------------
from device4xi import Device4Xi
from device4xi import init2device4xi 
from device4xi import set2device4xi
from device4xi import get2device4xi


# -------------------------------------------------------------------------------------------------
# Event module                           
# -------------------------------------------------------------------------------------------------
# None


# -------------------------------------------------------------------------------------------------
# Sampler module                           
# -------------------------------------------------------------------------------------------------
from sampler4xi import Sampler4Xi
from sampler4xi import create2sampler4xi
from sampler4xi import get2samplerinfo4xi
from sampler4xi import release2sampler4xi
from sampler4xi import retain2sampler4xi
from sampler4xi import set2samplercallback4xi 
from sampler4xi import set2sampler4xi
from sampler4xi import trace2sampler4xi

# -------------------------------------------------------------------------------------------------
# Platform module                           
# -------------------------------------------------------------------------------------------------
from platforminfo4xi import PlatformInfo4Xi                                                                        
from platforminfo4xi import init2platforminfo4xi
from platforminfo4xi import set2platforminfo4xi
from platforminfo4xi import get2platforminfo4xi

# -------------------------------------------------------------------------------------------------
# Trace modules                    
# -------------------------------------------------------------------------------------------------

                                                                                                                  # REMEMBER TO MODIFY NECESSARY MODULES BEFORE TESTS !!
                                                                                                                  
from print4xi import Print4Xi                                                                                     # edit print4xi.py - embeds trace for the functions and classes to be tested
from print4xi import print4xi                                                                                     # see OpenCl4Xi definitions in print4xi.py

from pickle4xi import pickle4xi                                                                                   # edit corresponding pickle2?4xi.py
from pickle2a4xi import Pickle2a4Xi
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi 

    
from actor2a4xi import Actor2a4Xi                                                                                   # define functions and class for zapping 
from actor2b4xi import Actor2b4Xi                                                                                   # not necessary for testing but got to be done later on!
from actor2c4xi import Actor2c4Xi
from actor2d4xi import Actor2d4Xi
from actor2e4xi import Actor2e4Xi
from actor2f4xi import Actor2f4Xi
from actor2g4xi import Actor2g4Xi
from actor2h4xi import Actor2h4Xi
from actor2i4xi import Actor2i4Xi
from actor2j4xi import Actor2j4Xi
from actor2k4xi import Actor2k4Xi
from actor2l4xi import Actor2l4Xi
from actor2m4xi import Actor2m4Xi
from actor2n4xi import Actor2n4Xi
from actor2o4xi import Actor2o4Xi
from actor2p4xi import Actor2p4Xi
from actor2q4xi import Actor2q4Xi
from actor2r4xi import Actor2r4Xi
from actor2s4xi import Actor2s4Xi
from actor2t4xi import Actor2t4Xi
from actor2u4xi import Actor2u4Xi
from actor2v4xi import Actor2v4Xi
from actor2w4xi import Actor2w4Xi
from actor2x4xi import Actor2x4Xi
from actor2y4xi import Actor2y4Xi
from actor2z4xi import Actor2z4Xi
from actor2_4xi import Actor2_4Xi
from time4xi import time4xi                                                                                         # time stamp to events

from xml_trace_sense4xi import xml_trace_sense4xi                                                                   # XML trace
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi 
#" 
#/>


# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global trace2scope 
global trace_object_count
global PickleKB4Xi
global KB2PU                                                                         
global keys2pu
global KB2CC
global keys2cc

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
KB2PU = {}                      # PROCESSING UNITS
KB2PU ['APU'] = {}
KB2PU ['BPU'] = {}
KB2PU ['CPU'] = {}
KB2PU ['DPU'] = {}
KB2PU ['EPU'] = {}
KB2PU ['FPU'] = {}
KB2PU ['GPU'] = {}
KB2PU ['HPU'] = {}
KB2PU ['IPU'] = {}
KB2PU ['JPU'] = {}
KB2PU ['KPU'] = {}
KB2PU ['LPU'] = {}
KB2PU ['MPU'] = {}
KB2PU ['NPU'] = {}
KB2PU ['OPU'] = {}
KB2PU ['PPU'] = {}
KB2PU ['QPU'] = {}
KB2PU ['RPU'] = {}
KB2PU ['SPU'] = {}
KB2PU ['TPU'] = {}
KB2PU ['UPU'] = {}
KB2PU ['VPU'] = {}
KB2PU ['WPU'] = {}
KB2PU ['XPU'] = {}
KB2PU ['YPU'] = {}
KB2PU ['ZPU'] = {}
keys2pu = KB2PU.keys()
                                # COMMAND & CONTROL FOR PROCESSING UNITS TO SELECT PROCESSING UNITS ENVOLVED IN TESTING
KB2CC = {}                      # ACK = GET INVOLVED NACK = SKIP
KB2CC ['APU'] = 'ACK'           # MODEL PROCESSING UNIT I.E. FIRST TO GET INVOLVED !
KB2CC ['BPU'] = 'NACK'
KB2CC ['CPU'] = 'NACK'
KB2CC ['DPU'] = 'NACK'
KB2CC ['EPU'] = 'NACK'
KB2CC ['FPU'] = 'NACK'
KB2CC ['GPU'] = 'ACK'
KB2CC ['HPU'] = 'NACK'
KB2CC ['IPU'] = 'NACK'
KB2CC ['JPU'] = 'NACK'
KB2CC ['KPU'] = 'NACK'
KB2CC ['LPU'] = 'NACK'
KB2CC ['MPU'] = 'NACK'
KB2CC ['NPU'] = 'NACK'
KB2CC ['OPU'] = 'NACK'
KB2CC ['PPU'] = 'NACK'
KB2CC ['QPU'] = 'NACK'
KB2CC ['RPU'] = 'NACK'
KB2CC ['SPU'] = 'NACK'
KB2CC ['TPU'] = 'NACK'
KB2CC ['UPU'] = 'NACK'
KB2CC ['VPU'] = 'NACK'
KB2CC ['WPU'] = 'NACK'
KB2CC ['XPU'] = 'NACK'
KB2CC ['YPU'] = 'NACK'
KB2CC ['ZPU'] = 'ACK'
keys2cc = KB2CC.keys()



PickleKB4Xi = {
       'a': Pickle2a4Xi,
       # 
       'b': Pickle2b4Xi,
       # 
       'c': Pickle2c4Xi,
       # 
       'd': Pickle2d4Xi,
       # 
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi} 
#"
#"/>


# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "set2trace4xi" usage = "setting trace using definitions in pickle4xi functions !
#">                      
# ----------------------------------------------------------------------------------------------------------    
def set2trace4xi():
    global trace2scope 
    global trace_object_count
    global PickleKB4Xi

    # print("(Step 0A/33) OF SET2TRACE4XI - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    # print("(Step 0B/33) OF SET2TRACE4XI - USING T2XI: ", trace2scope)
    # <print4xi.Print4Xi object at 0x0000000003715080>    
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
   
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # 
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                trace2scope.set_print_permission(key_param, set_param2xi)
                # print("(Step 2A/33) OF SET2TRACE4XI - MARKED TO BE TRACED OBJECT: ", object2pickle)                                
                # 
            else:
                pass  
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    print('=' *33)
    print("(Step 33/33) OF SET2TRACE4XI - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print('=' *33)
#</function4xi> 

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "deny2trace4xi" usage = "
#   deny trace using pickle4xi functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def deny2trace4xi():
    global trace2scope 
    global trace_object_count
    global PickleKB4Xi

    print("(Step 01A/33) of DENY2TRACE4XI: STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print("(Step 01B/33) OF DENY2TRACE4XI - USING T2XI: ", trace2scope)
    # <print4xi.Print4Xi object at 0x0000000003715080>
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02A/33) OF DENY2TRACE4XI - STARTING LETTER : ", key2pickledb)
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("(Step 02B/33) OF DENY2TRACE4XI - STARTING DICTIONARY: ", dictionary2pickle)
        keys2dictionary = sorted(dictionary2pickle.keys())
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
   
            object2pickle = key2dictionary        
            # print("(Step 02C/33) OF DENY2TRACE4XI - STARTING OBJECT: ", object2pickle)
            # pickle4xi(object2pickle)        
            # print("STEP: PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # ACK4XI = tested .i.e. NOT to be traced! 
            # ---------------------------------------------------------------------------------     
            set_param2xi = 'ACK4XI'     
            key_param = object2pickle     
            trace2scope.set_print_permission(key_param, set_param2xi)
            # print("(Step 02D/33) OF DENY2TRACE4XI - MARKED TESTED AND NOT to be traced: ", object2pickle)
            
            dictionary2pickle[key2dictionary] = 'ACK4XI' 
                    
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("(Step 02Z/33) OF DENY2TRACE4XI *** FAILED - ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02E/33) OF DENY2TRACE4XI - COMPLETED  DICTIONARY: ", dictionary2pickle)
        # 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print("(Step 02F/33) OF DENY2TRACE4XI - COMPLETED LETTER : ", key2pickledb)
    # _, a ... z            
    print("(Step 033/33) OF SET2TRACE4XI - COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "tailor2trace4xi" usage = "
#   tailors trace 
#">                      
# -------------------------------------------------------------------------------------------------    
def tailor2trace4xi():
    global trace_object_count
    global PickleKB4Xi 
    global trace2scope
 
    print("(Step 001A/33) OF TAILOR2TRACE4XI - USING T2XI: ", trace2scope)
    # <print4xi.Print4Xi object at 0x0000000003715080> 
                         
    # ---------------------------------------------------------------------------------------------
    # Settings to tailor trace
    # ---------------------------------------------------------------------------------------------
    #<set4xi setting = "
    KB4Tailoring = {
           'APU2Sampler4Xi':          'NACK4XI',   # APU
           'create2sampler4apu':      'NACK4XI',
#          'get2samplerinfo4apu':     'NACK4XI',
#          'retain2sampler4apu':      'NACK4XI',
#          'release2sampler4apu':     'NACK4XI',
#          'trace2sampler4apu':       'NACK4XI',
#          'set2samplercallback4apu': 'NACK4XI',
#          'set2sampler4apu':         'NACK4XI',
#          'ZPU2Sampler4Xi':          'NACK4XI',   # ZPU
#          'create2sampler4zpu':      'NACK4XI',
#          'get2samplerinfo4zpu':     'NACK4XI',
#          'retain2sampler4zpu':      'NACK4XI',
#          'release2sampler4zpu':     'NACK4XI',
#          'trace2sampler4zpu':       'NACK4XI',
#          'set2samplercallback4zpu': 'NACK4XI',
#          'set2sampler4zpu':         'NACK4XI',
           'Sampler4Xi':              'NACK4XI',   # XI
           'create2sampler4xi':       'NACK4XI',
#          'get2samplerinfo4xi':      'NACK4XI',
#          'retain2sampler4xi':       'NACK4XI',
#          'release2sampler4xi':      'NACK4XI',
#          'trace2sampler4xi':        'NACK4XI',
#          'set2samplercallback4xi':  'NACK4XI',
#          'set2sampler4xi':          'NACK4XI'  
        }                              
                
    default3trace = 'NACK4TRACE' # we do NOT want trace if object is not found! 
    #"/>
    
    # ---------------------------------------------------------------------------------------------
    # PROCESS KB4Tailoring
    # ---------------------------------------------------------------------------------------------
    keys2tailor = sorted(KB4Tailoring.keys())
    for key2tailor in keys2tailor:
        # ---------------------------------------------------------------------------------    
        # NACK4XI = NOT TESTED .I.E. TO BE TRACED! 
        # ---------------------------------------------------------------------------------     
        set_param2xi = 'NACK4XI'     
        key_param = key2tailor    
        trace2scope.set_print_permission(key_param, set_param2xi)
        print("(Step 002A/33) OF TAILOR_TRACE4XI - MARKED TO BE TESTED: ", key2tailor)
        # 
        
    # -----------------------------------------------------------------------------------------    
    # EOF KEYS
    # -----------------------------------------------------------------------------------------     
    print("(Step 0033/33) OF TAILOR_TRACE4XI - COMPLETED  TAILORING: ", time4xi())
    #

#</function4xi>              


    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "print-trace4xi" usage = "
# print XML trace for sampler4xi test
#"> 
# -------------------------------------------------------------------------------------------------    
def print2trace4xi(trace2scope):
       

    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
   
    context2sense = {
     'file_path4xi': 'E:\\scope4xi\\041721\\zap\\web\\xml\\sense-sampler4xi5test.xml',
     'name_space4xi': '   xmlns="http://www.yourdragonxi.org/sw4xi/python33/owl/multiprocessing4dragon.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourdragonxi.org/web/lib/owl/scope4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing of OpenCl4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="Dragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Sensing Sampler of XI.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">Sampler of XI sensed.</rdfs:comment>\n',
     'debug4xi': True}
      
    xml_trace_sense4xi(trace2scope, context2sense)

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    context2reason = {
     'file_path4xi': 'E:\\scope4xi\\041721\\zap\\web\\xml\\reason-sampler4xi5test.xml',
     'name_space4xi': '   xmlns="http://www.yourdragonxi.org/sw4xi/python33/owl/multiprocessing4dragon.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourdragonxi.org/web/lib/owl/scope4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of OpenCl4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for Sampler of XI.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations with context.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n',
     'debug4xi': True}
       
    xml_trace_reason4xi(trace2scope, context2reason)

    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    context2ace = {
     'file_path4xi': 'E:\\scope4xi\\041721\\zap\\web\\xml\\ace-sampler4xi5test.xml',
     'name_space4xi': '   xmlns="http://www.yourdragonxi.org/sw4xi/python33/owl/multiprocessing4dragon.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourdragonxi.org/web/lib/owl/scope4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of OpenCl4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for Sampler of XI.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values of Sampler of XI.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n',
     'debug4xi': True}   
    
    xml_trace_ace4xi(trace2scope, context2ace)


    # -------------------------------------------------------------------------------------------------
    # end of print2trace4xi                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>
       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "sampler4xi5test" usage = "
#   tests sampler4xi
#"> 
# -------------------------------------------------------------------------------------------------    
def sampler4xi5test():
    global trace2scope 
    global KB2PU
    global keys2pu
    global KB2CC
    global keys2cc    
 
    # ---------------------------------------------------------------------------------------------
    # INITIALIZE                          
    # ---------------------------------------------------------------------------------------------    
    sampler4xi = {}                                                      # SAMPLERS
    
    samplertrace4xi = {}                                                 # TRACE
    
    platform2xi = {}                                                     # PLATFORM
    device2xi   = {}                                                     # DEVICE
    context2xi  = {}                                                     # CONTEXT
    


    # ---------------------------------------------------------------------------------------------
    # START TESTING                          
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 1A/700) OF SAMPLER4XI5TEST - STARTED ', time4xi()) 
    print('=' *33)   
    # 03:10:30 11/09/11 Pacific Standard Time
            
    # ---------------------------------------------------------------------------------------------
    # PHASE I: FUNCTION TESTS - CREATE SAMPLERS FOR XI WITH FUNCTION                          
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 2A/700) OF SAMPLER4XI5TEST - TRYING TO CREATE SAMPLERS FOR XI ', time4xi())      
    print('=' *33)        
    # 
    try:
        response4createsampler = create2sampler4xi()                                                                 
        print('(Step 2B/700) OF SAMPLER4XI5TEST - CREATED SAMPLER4XI ', time4xi())
        keys2response = response4createsampler.keys()
        for key2response in sorted(keys2response):
            print(key2response, ' : ', response4createsampler[key2response])
            # APU  :  {'CODE2ERROR': 0, 
            #          'COUNT2REFERENCE': 1, 
            #          'DATA2CALLBACK': {'MESSAGE': '{(Step 1Z1/33) failed; create2sampler4apu-failed ; time: 00:44:52 11/09/11 Pacific Standard Time}', 'CLASS': 'create2sampler4apu', 'METHOD': 'create2sampler4apu'}, 
            #          'BUFFER': {'CODE2ERROR': 0 ..
            #          'CONTEXT': {'COUNT2REFERENCE': 0 ...
            # 'PLATFORM': {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}, 'NACK2RETURN': ' ', 'SIZE2PRIVATE': 0, 'PROPERTIES': None}, 
            # 'DEVICE': {'RESOLUTION2TIMER4PROFILING': 318 ...
            # ...
            # ZPU  :  ...
            
    except:
        print('(Step 2Z1/700) OF SAMPLER4XI5TEST *** FAILED TO CREATE CREATE SAMPLERS FOR XI ', time4xi()) 
         
        
                   
    # ---------------------------------------------------------------------------------------------
    # PHASE I: FUNCTION TESTS - GET SOME SAMPLER INFO OF SELECTED PROCESSING UNITS WITH FUNCTION                
    # ---------------------------------------------------------------------------------------------    
    print('(Step 3B1/700) OF SAMPLER4XI5TEST - TRYING TO GET SOME SAMPLER INFO OF SELECTED PROCESSING UNITS ', time4xi())          
    try:
        task4getinfo2sampler = {}
        kb2task = {}
        kb2task ['APU'] = {}
        kb2task ['GPU'] = {}
        kb2task ['PPU'] = {}
        kb2task ['ZPU'] = {}
        keys2task = kb2task.keys()
        for key2task in sorted(keys2task):
            task4getinfo2sampler [key2task] = {}
            task4getinfo2sampler [key2task] ['NORMALIZATION']   = 'YES'            
            task4getinfo2sampler [key2task] ['ADDRESSINGMODE']  = 'YES'   
            task4getinfo2sampler [key2task] ['FILTERINGMODE']   = 'YES'   
               
        response4getinfosampler = get2samplerinfo4xi(task4getinfo2sampler)                                                                      
        keys2response = response4getinfosampler.keys()
        for key2response in sorted(keys2response):
            print(key2response, ' : ', response4getinfosampler[key2response]) 
            # APU  :  {'FILTERINGMODE': 'CL_FILTER_NEAREST', 'NORMALIZATION': 'CL_TRUE', 'ADDRESSINGMODE': 'CL_ADDRESS_MIRRORED_REPEAT'}
            # GPU  :  {'FILTERINGMODE': 'CL_FILTER_NEAREST', 'NORMALIZATION': 'CL_TRUE', 'ADDRESSINGMODE': 'CL_ADDRESS_MIRRORED_REPEAT'}
            # PPU  :  {'FILTERINGMODE': 'CL_FILTER_NEAREST', 'NORMALIZATION': 'CL_TRUE', 'ADDRESSINGMODE': 'CL_ADDRESS_MIRRORED_REPEAT'}
            # ZPU  :  {'FILTERINGMODE': 'CL_FILTER_NEAREST', 'NORMALIZATION': 'CL_TRUE', 'ADDRESSINGMODE': 'CL_ADDRESS_MIRRORED_REPEAT'} 
            
    except:
        print('(Step 3Z3/700) OF SAMPLER4XI5TEST *** FAILED TO GET SOME SAMPLER INFO OF SELECTED PROCESSING UNITS ', time4xi())
     
    
                        
    # ---------------------------------------------------------------------------------------------
    # PHASE I: FUNCTION TESTS - GET ALL SAMPLER INFO OF SELECTED PROCESSING UNITS                
    # ---------------------------------------------------------------------------------------------             
    print('=' *33)          
    print('(Step 3C1/700) OF SAMPLER4XI5TEST - TRYING TO GET ALL SAMPLER INFO OF SELECTED PROCESSING UNITS ', time4xi()) 
    print('=' *33)       
    try:
        for key2task in sorted(keys2task):
            task4getinfo2sampler [key2task] = {}
            task4getinfo2sampler [key2task] ['DOMAIN'] = 'ALL'    
        
        response4getinfosampler = get2samplerinfo4xi(task4getinfo2sampler)                                                                      
                                                                   
        print('(Step 3C2/700) OF SAMPLER4XI5TEST - GOT ALL SAMPLER INFO FOR XI ', time4xi()) 
        keys2response = response4getinfosampler.keys()
        for key2response in sorted(keys2response):
            print(key2response, ' : ', response4getinfosampler[key2response])
            # APU  :  {'CODE2ERROR': 0 ...
            # ...
            # ZPU  :  {'CODE2ERROR': 0
            

    except:
        print('(Step 3Z4/700) OF SAMPLER4XI5TEST *** FAILED TO GET ALL SAMPLER INFO OF SELECTED PROCESSING UNITS ', time4xi()) 

            
    # ---------------------------------------------------------------------------------------------------
    # PHASE I: FUNCTION TESTS - SET SAMPLERS WITH FUNCTION TO ALL PROCESSING UNITS - ALL ATTRIBUTES                         
    # ---------------------------------------------------------------------------------------------------    
    #   
    print('(Step 4A/700) OF SAMPLER4XI5TEST - TRYING TO SET SAMPLERS WITH FUNCTION TO ALL PROCESSING UNITS ', time4xi())    

    KB2setsampler = {}
    KB2setsampler ['APU'] = {}
    KB2setsampler ['BPU'] = {}
    KB2setsampler ['CPU'] = {}
    KB2setsampler ['DPU'] = {}
    KB2setsampler ['EPU'] = {}
    KB2setsampler ['FPU'] = {}
    KB2setsampler ['GPU'] = {}
    KB2setsampler ['HPU'] = {}
    KB2setsampler ['IPU'] = {}
    KB2setsampler ['JPU'] = {}
    KB2setsampler ['KPU'] = {}
    KB2setsampler ['LPU'] = {}
    KB2setsampler ['MPU'] = {}
    KB2setsampler ['NPU'] = {}
    KB2setsampler ['OPU'] = {}
    KB2setsampler ['PPU'] = {}
    KB2setsampler ['QPU'] = {}
    KB2setsampler ['RPU'] = {}
    KB2setsampler ['SPU'] = {}
    KB2setsampler ['TPU'] = {}
    KB2setsampler ['UPU'] = {}
    KB2setsampler ['VPU'] = {}
    KB2setsampler ['WPU'] = {}
    KB2setsampler ['XPU'] = {}
    KB2setsampler ['YPU'] = {}
    KB2setsampler ['ZPU'] = {}
    keys2setsampler = KB2setsampler.keys()
    
    task4set2sampler = {} 

    # ---------------------------------------------------------------------------------------------
    # (4A) GET PLATFORM IDs TO SET CONTEXT
    # ---------------------------------------------------------------------------------------------    
    print('(Step 4A1/700) OF SAMPLER4XI5TEST - TRYING TO GET PLATFORMIDS4XI', time4xi())
    try:
        platform2xi = get2platformids4xi()
        print('(Step 4A2/33) OF SAMPLER4XI5TEST - GOT PLATFORMIDS4XI', platform2xi) 
        # {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}
         
    except:
        print('(Step 4AZ/33) OF SAMPLER4XI5TEST *** FAILED TO GET PLATFORMIDS4XI', time4xi())     
    
    # ---------------------------------------------------------------------------------------------
    # (4B) INITIALIZE XI DEVICE                       
    # ---------------------------------------------------------------------------------------------    
    print('(Step 4B1/33) OF SAMPLER4XI5TEST - TRYING TO INITIALIZE DEVICE4XI ', time4xi())   
    try:
        device2xi = init2device4xi()                                                                                
        keys2device = device2xi.keys()
        for key2device in sorted(keys2device):
            print(key2device, device2xi[key2device])
            # APU {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM' ...
            # ...
            # ZPU {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM' ... 
    except:
        print('(Step 4BZ/33) OF SAMPLER4XI5TEST *** FAILED TO INITIALIZE DEVICE4XI', time4xi())  
                
            
    # ---------------------------------------------------------------------------------------------
    # (4C) CREATE XI CONTEXT                  
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 4C1/700) OF SAMPLER4XI5TEST - TRYING TO CREATE CONTEXT4XI ', time4xi())    
    print('=' *33)        
    try:
        context2xi = create2context4xi()                                                                            
        keys2context = context2xi.keys()
        for key2context in sorted(keys2context):
            print(key2context, device2xi[key2context])
            # APU {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK' ...
            # ...
            # ZPU {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK' ...   
    except:
        print('(Step 4CZ/700) OF SAMPLER4XI5TEST *** FAILED TO CREATE CONTEXT4XI', time4xi()) 
        
            
    # ---------------------------------------------------------------------------------------------
    # (4D) CREATE XI COMMANDQUEUE                
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 4D1/700) OF SAMPLER4XI5TEST - TRYING TO CREATE COMMANDQUEUE ', time4xi())    
    print('=' *33)        
    try:
        queue4command = create2commandqueue4xi()                                                                            
        keys2commandqueue = queue4command.keys()
        for key2commandqueue in sorted(keys2commandqueue):
            print(key2commandqueue, queue4command[key2commandqueue])
            # APU {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': ...
            # ...
            # ZPU {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': ...
              
    except:
        print('(Step 4DZ/700) OF SAMPLER4XI5TEST *** FAILED TO CREATE COMMANDQUEUE', time4xi())         
    
    # -------------------------------------------------------------------------------------------------    
    # (5) INITIALIZE TASK4SET2SAMPLER FOR PROCESSING UNITS              
    # -------------------------------------------------------------------------------------------------          
    print('(Step 5A/700) OF SAMPLER4XI5TEST - TRYING TO INITIALIZE TASK4SET2SAMPLER FOR PROCESSING UNITS ', time4xi())
    try:
        for key2setsampler in sorted(keys2setsampler):
            task4set2sampler [key2setsampler] = {}
            print(key2setsampler, task4set2sampler [key2setsampler])
            # 
            
    except:
        print('(Step 5Z/700) OF SAMPLER4XI5TEST *** FAILED TO INITIALIZE TASK4SET2SAMPLER FOR PROCESSING UNITS ', time4xi())
                    
    # -------------------------------------------------------------------------------------------------    
    # (5) SET CONTEXT OF TASK4SET2SAMPLER FOR PROCESSING UNITS              
    # -------------------------------------------------------------------------------------------------          
    print('(Step 5A/700) OF SAMPLER4XI5TEST - TRYING TO SET CONTEXT OF TASK4SET2SAMPLER FOR PROCESSING UNITS ', time4xi())
    try:
        for key2setsampler in sorted(keys2setsampler):
            task4set2sampler [key2setsampler] ['CONTEXT'] = context2xi [key2setsampler] 
            print(key2setsampler, ' CONTEXT: ', task4set2sampler [key2setsampler] ['CONTEXT'])
            # 
                 
    except:
        print('(Step 5Z/700) OF SAMPLER4XI5TEST *** FAILED TO SET CONTEXT OF TASK4SET2SAMPLER FOR PROCESSING UNITS ', time4xi()) 
        
    # -------------------------------------------------------------------------------------------------    
    # (6) SET DEVICE OF TASK4SET2SAMPLER FOR PROCESSING UNITS              
    # -------------------------------------------------------------------------------------------------          
    print('(Step 6A/700) OF SAMPLER4XI5TEST - TRYING TO SET DEVICE OF TASK4SET2SAMPLER FOR PROCESSING UNITS ', time4xi())
    try:
        for key2setsampler in sorted(keys2setsampler):        
            task4set2sampler [key2setsampler] ['DEVICE'] = device2xi [key2setsampler] 
            print(key2setsampler, 'DEVICE:' , task4set2sampler [key2setsampler] ['DEVICE'])
            # 
             
    except:
        print('(Step 6Z/700) OF SAMPLER4XI5TEST *** FAILED TO SET DEVICE OF TASK4SET2SAMPLER FOR PROCESSING UNITS ', time4xi())

        
    # -------------------------------------------------------------------------------------------------    
    # (7) SET PROPERTIES OF TASK4SET2SAMPLER FOR PROCESSING UNITS              
    # -------------------------------------------------------------------------------------------------          
    print('(Step 7A/700) OF SAMPLER4XI5TEST - TRYING TO SET PROPERTIES FOR PROCESSING UNITS ', time4xi())
    try:
        for key2setsampler in sorted(keys2setsampler):        
            task4set2sampler [key2setsampler] ['PROPERTIES'] = None
            task4set2sampler [key2setsampler] ['CODE2ERROR'] = 0  
            print(key2setsampler, 'PROPERTIES: ', task4set2sampler [key2setsampler] ['PROPERTIES'], ' CODE2ERROR: ', task4set2sampler [key2setsampler] ['CODE2ERROR'])
            # 
             
    except:
        print('(Step 7Z/700) OF SAMPLER4XI5TEST *** FAILED TO SET PROPERTIES OF TASK4SET2SAMPLER FOR PROCESSING UNITS ', time4xi())

        
    # -------------------------------------------------------------------------------------------------    
    # (8) SET QUEUE OF TASK4SET2SAMPLER FOR PROCESSING UNITS              
    # -------------------------------------------------------------------------------------------------          
    print('(Step 8A/700) OF SAMPLER4XI5TEST - TRYING TO SET QUEUE FOR PROCESSING UNITS ', time4xi())
    try:
        for key2setsampler in sorted(keys2setsampler):        
            task4set2sampler [key2setsampler] ['QUEUE'] = Queue4Xi()
            print(key2setsampler, ' QUEUE: ', task4set2sampler [key2setsampler] ['QUEUE'])
            # 
             
    except:
        print('(Step 8Z/700) OF SAMPLER4XI5TEST *** FAILED TO SET QUEUE OF TASK4SET2SAMPLER FOR PROCESSING UNITS ', time4xi())
                
        
    # -------------------------------------------------------------------------------------------------    
    # (9) SET PIPE OF TASK4SET2SAMPLER FOR PROCESSING UNITS              
    # -------------------------------------------------------------------------------------------------          
    print('(Step 9A/700) OF SAMPLER4XI5TEST - TRYING TO SET PIPE FOR PROCESSING UNITS ', time4xi())
    try:
        for key2setsampler in sorted(keys2setsampler):        
            task4set2sampler  [key2setsampler] ['PIPE'] = Pipe4Xi() 
            print(key2setsampler, ' PIPE: ', task4set2sampler  [key2setsampler] ['PIPE']) 
            # 
            
    except:
        print('(Step 9Z/700) OF SAMPLER4XI5TEST *** FAILED TO SET PIPE OF TASK4SET2SAMPLER FOR PROCESSING UNITS ', time4xi())
        
        
    # -------------------------------------------------------------------------------------------------    
    # (9B) SET NORMALIZATION OF TASK4SET2SAMPLER FOR PROCESSING UNITS              
    # -------------------------------------------------------------------------------------------------          
    print('(Step 9B/700) OF SAMPLER4XI5TEST - TRYING TO SET NORMALIZATION FOR PROCESSING UNITS ', time4xi())
    try:
        for key2setsampler in sorted(keys2setsampler):        
            task4set2sampler  [key2setsampler] ['NORMALIZATION'] = 'CL_TRUE' 
            print(key2setsampler, ' NORMALIZATION: ', task4set2sampler  [key2setsampler] ['NORMALIZATION'])
            # APU  NORMALIZATION:  CL_TRUE
            # BPU  NORMALIZATION:  CL_TRUE
            # CPU  NORMALIZATION:  CL_TRUE
            # DPU  NORMALIZATION:  CL_TRUE
            # EPU  NORMALIZATION:  CL_TRUE
            # FPU  NORMALIZATION:  CL_TRUE
            # GPU  NORMALIZATION:  CL_TRUE
            # HPU  NORMALIZATION:  CL_TRUE
            # IPU  NORMALIZATION:  CL_TRUE
            # JPU  NORMALIZATION:  CL_TRUE
            # KPU  NORMALIZATION:  CL_TRUE
            # LPU  NORMALIZATION:  CL_TRUE
            # MPU  NORMALIZATION:  CL_TRUE
            # NPU  NORMALIZATION:  CL_TRUE
            # OPU  NORMALIZATION:  CL_TRUE
            # PPU  NORMALIZATION:  CL_TRUE
            # QPU  NORMALIZATION:  CL_TRUE
            # RPU  NORMALIZATION:  CL_TRUE
            # SPU  NORMALIZATION:  CL_TRUE
            # TPU  NORMALIZATION:  CL_TRUE
            # UPU  NORMALIZATION:  CL_TRUE
            # VPU  NORMALIZATION:  CL_TRUE
            # WPU  NORMALIZATION:  CL_TRUE
            # XPU  NORMALIZATION:  CL_TRUE
            # YPU  NORMALIZATION:  CL_TRUE
            # ZPU  NORMALIZATION:  CL_TRUE
            
             
    except:
        print('(Step 9Z2/700) OF SAMPLER4XI5TEST *** FAILED TO SET NORMALIZATION OF TASK4SET2SAMPLER FOR PROCESSING UNITS ', time4xi())
        
        
    # -------------------------------------------------------------------------------------------------    
    # (9C) SET ADDRESSINGMODE OF TASK4SET2SAMPLER FOR PROCESSING UNITS              
    # -------------------------------------------------------------------------------------------------          
    print('(Step 9C/700) OF SAMPLER4XI5TEST - TRYING TO SET ADDRESSINGMODE FOR PROCESSING UNITS ', time4xi())
    try:
        for key2setsampler in sorted(keys2setsampler):        
            task4set2sampler  [key2setsampler] ['ADDRESSINGMODE'] = 'CL_ADDRESS_CLAMP_TO_EDGE'
            print(key2setsampler, ' ADDRESSINGMODE: ', task4set2sampler  [key2setsampler] ['ADDRESSINGMODE'])
            # APU  ADDRESSINGMODE:  CL_ADDRESS_CLAMP_TO_EDGE
            # BPU  ADDRESSINGMODE:  CL_ADDRESS_CLAMP_TO_EDGE
            # CPU  ADDRESSINGMODE:  CL_ADDRESS_CLAMP_TO_EDGE
            # DPU  ADDRESSINGMODE:  CL_ADDRESS_CLAMP_TO_EDGE
            # EPU  ADDRESSINGMODE:  CL_ADDRESS_CLAMP_TO_EDGE
            # FPU  ADDRESSINGMODE:  CL_ADDRESS_CLAMP_TO_EDGE
            # GPU  ADDRESSINGMODE:  CL_ADDRESS_CLAMP_TO_EDGE
            # HPU  ADDRESSINGMODE:  CL_ADDRESS_CLAMP_TO_EDGE
            # IPU  ADDRESSINGMODE:  CL_ADDRESS_CLAMP_TO_EDGE
            # JPU  ADDRESSINGMODE:  CL_ADDRESS_CLAMP_TO_EDGE
            # KPU  ADDRESSINGMODE:  CL_ADDRESS_CLAMP_TO_EDGE
            # LPU  ADDRESSINGMODE:  CL_ADDRESS_CLAMP_TO_EDGE
            # MPU  ADDRESSINGMODE:  CL_ADDRESS_CLAMP_TO_EDGE
            # NPU  ADDRESSINGMODE:  CL_ADDRESS_CLAMP_TO_EDGE
            # OPU  ADDRESSINGMODE:  CL_ADDRESS_CLAMP_TO_EDGE
            # PPU  ADDRESSINGMODE:  CL_ADDRESS_CLAMP_TO_EDGE
            # QPU  ADDRESSINGMODE:  CL_ADDRESS_CLAMP_TO_EDGE
            # RPU  ADDRESSINGMODE:  CL_ADDRESS_CLAMP_TO_EDGE
            # SPU  ADDRESSINGMODE:  CL_ADDRESS_CLAMP_TO_EDGE
            # TPU  ADDRESSINGMODE:  CL_ADDRESS_CLAMP_TO_EDGE
            # UPU  ADDRESSINGMODE:  CL_ADDRESS_CLAMP_TO_EDGE
            # VPU  ADDRESSINGMODE:  CL_ADDRESS_CLAMP_TO_EDGE
            # WPU  ADDRESSINGMODE:  CL_ADDRESS_CLAMP_TO_EDGE
            # XPU  ADDRESSINGMODE:  CL_ADDRESS_CLAMP_TO_EDGE
            # YPU  ADDRESSINGMODE:  CL_ADDRESS_CLAMP_TO_EDGE
            # ZPU  ADDRESSINGMODE:  CL_ADDRESS_CLAMP_TO_EDGE
             
    except:
        print('(Step 9Z3/700) OF SAMPLER4XI5TEST *** FAILED TO SET ADDRESSINGMODE OF TASK4SET2SAMPLER FOR PROCESSING UNITS ', time4xi())
        
        
    # -------------------------------------------------------------------------------------------------    
    # (9D) SET FILTERINGMODE OF TASK4SET2SAMPLER FOR PROCESSING UNITS              
    # -------------------------------------------------------------------------------------------------          
    print('(Step 9D/700) OF SAMPLER4XI5TEST - TRYING TO SET FILTERINGMODE FOR PROCESSING UNITS ', time4xi())
    try:
        for key2setsampler in sorted(keys2setsampler):        
            task4set2sampler  [key2setsampler] ['FILTERINGMODE'] = 'CL_FILTER_LINEAR'
            print(key2setsampler, ' FILTERINGMODE: ', task4set2sampler  [key2setsampler] ['FILTERINGMODE'])
            # APU  FILTERINGMODE:  CL_FILTER_LINEAR
            # BPU  FILTERINGMODE:  CL_FILTER_LINEAR
            # CPU  FILTERINGMODE:  CL_FILTER_LINEAR
            # DPU  FILTERINGMODE:  CL_FILTER_LINEAR
            # EPU  FILTERINGMODE:  CL_FILTER_LINEAR
            # FPU  FILTERINGMODE:  CL_FILTER_LINEAR
            # GPU  FILTERINGMODE:  CL_FILTER_LINEAR
            # HPU  FILTERINGMODE:  CL_FILTER_LINEAR
            # IPU  FILTERINGMODE:  CL_FILTER_LINEAR
            # JPU  FILTERINGMODE:  CL_FILTER_LINEAR
            # KPU  FILTERINGMODE:  CL_FILTER_LINEAR
            # LPU  FILTERINGMODE:  CL_FILTER_LINEAR
            # MPU  FILTERINGMODE:  CL_FILTER_LINEAR
            # NPU  FILTERINGMODE:  CL_FILTER_LINEAR
            # OPU  FILTERINGMODE:  CL_FILTER_LINEAR
            # PPU  FILTERINGMODE:  CL_FILTER_LINEAR
            # QPU  FILTERINGMODE:  CL_FILTER_LINEAR
            # RPU  FILTERINGMODE:  CL_FILTER_LINEAR
            # SPU  FILTERINGMODE:  CL_FILTER_LINEAR
            # TPU  FILTERINGMODE:  CL_FILTER_LINEAR
            # UPU  FILTERINGMODE:  CL_FILTER_LINEAR
            # VPU  FILTERINGMODE:  CL_FILTER_LINEAR
            # WPU  FILTERINGMODE:  CL_FILTER_LINEAR
            # XPU  FILTERINGMODE:  CL_FILTER_LINEAR
            # YPU  FILTERINGMODE:  CL_FILTER_LINEAR
            # ZPU  FILTERINGMODE:  CL_FILTER_LINEAR
             
    except:
        print('(Step 9Z3/700) OF SAMPLER4XI5TEST *** FAILED TO SET FILTERINGMODE OF TASK4SET2SAMPLER FOR PROCESSING UNITS ', time4xi())                                                                  
        
    # ---------------------------------------------------------------------------------------------
    # (10) FINALLY SET SAMPLER AFTER HAVING PROVIDED VALUES FOR REQUIRED PROCESSING UNITS                            
    # ---------------------------------------------------------------------------------------------          
    response4setsampler = {} 
    print('(Step 10A/700) OF SAMPLER4XI5TEST - TRYING TO SET SAMPLER4XI ', time4xi())   
    try:                               
        response4setsampler = set2sampler4xi(task4set2sampler)                                                                                                         
                                                                                      
        print('(Step 10B/700) OF SAMPLER4XI5TEST - SET SAMPLER4XI ', time4xi())
        keys2response = response4setsampler.keys()
        for key2response in sorted(keys2response):
            print(key2response, ' : ', response4setsampler[key2response])
            # APU  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 1,...  
            #          'ADDRESSINGMODE': 'CL_ADDRESS_MIRRORED_REPEAT'... 
            #          'FILTERINGMODE': 'CL_FILTER_NEAREST' ... 
            #          'NORMALIZATION': 'CL_TRUE' ...)}
            #
            # ZPU  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 1,...  
            #          'ADDRESSINGMODE': 'CL_ADDRESS_MIRRORED_REPEAT'... 
            #          'FILTERINGMODE': 'CL_FILTER_NEAREST' ... 
            #          'NORMALIZATION': 'CL_TRUE' ...)}
            
            
    except:
        print('(Step 10Z/700) OF SAMPLER4XI5TEST *** FAILED TO SET SAMPLER4XI *** ', time4xi())  
            

    
    
    # ---------------------------------------------------------------------------------------------
    # (11) REFERENCE COUNT FOR PROCESSING UNITS RELEASED BY DECREMENTING COUNT WITH 1             
    # ---------------------------------------------------------------------------------------------    
    task4release2sampler  = {}
    task4release2sampler ['APU']  = {}
    task4release2sampler ['APU'] ['COUNT2REFERENCE'] = 1
    task4release2sampler ['ZPU']  = {}
    task4release2sampler ['ZPU'] ['COUNT2REFERENCE'] = 1     
    response4release2sampler = {}    
       
    print('(Step 11A/700) OF SAMPLER4XI5TEST - TRYING TO RELEASE SAMPLER OF XI DEVICE ', time4xi())    
    # 
    try:                               
        response4releasesampler = release2sampler4xi(task4release2sampler)                                                                                             
        print('(Step 11B/700) OF SAMPLER4XI5TEST - RELEASED SAMPLER OF XI DEVICE ', time4xi())                           
        keys2response = response4releasesampler.keys()
        for key2response in sorted(keys2response):
            print(key2response, ' : ', response4releasesampler[key2response])
            # APU  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, ... 
            # BPU  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 1, ... 
            # ...
            # ZPU  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, ...  
                      
    except:
        print('(Step 11Z/700) OF SAMPLER4XI5TEST *** FAILED TO RELEASE SAMPLER OF XI DEVICE ', time4xi())
    
    
           
    # ---------------------------------------------------------------------------------------------
    # (12) NORMALIZATION, ADDRESSINGMODE AND  FILTERINGMODE ACCESSED FROM APU, GPU and ZPU           
    # ---------------------------------------------------------------------------------------------       
    task4getinfo2sampler = {}
    task4getinfo2sampler ['APU'] = {}
    task4getinfo2sampler ['APU'] ['NORMALIZATION'] =  'YES'
    task4getinfo2sampler ['APU'] ['ADDRESSINGMODE'] = 'YES'
    task4getinfo2sampler ['APU'] ['FILTERINGMODE'] =  'YES'
            
    task4getinfo2sampler ['GPU'] = {}
    task4getinfo2sampler ['GPU'] ['NORMALIZATION'] =  'YES'
    task4getinfo2sampler ['GPU'] ['ADDRESSINGMODE'] = 'YES'
    task4getinfo2sampler ['GPU'] ['FILTERINGMODE'] =  'YES'
                
    task4getinfo2sampler ['ZPU'] = {}
    task4getinfo2sampler ['ZPU'] ['NORMALIZATION'] =  'YES'
    task4getinfo2sampler ['ZPU'] ['ADDRESSINGMODE'] = 'YES'
    task4getinfo2sampler ['ZPU'] ['FILTERINGMODE'] =  'YES'
    
    
    print('(Step 12A/700) OF SAMPLER4XI5TEST - TRYING TO GET SELECTED SAMPLER INFO OF XI DEVICE ', time4xi())      
    # 
    try:                               
        response4getinfosampler = get2samplerinfo4xi (task4getinfo2sampler)                                                                                             
        keys2response = response4getinfosampler.keys()
        print('(Step 12B/700) OF SAMPLER4XI5TEST - GOT SELECTED SAMPLER INFO OF XI DEVICE ', time4xi())   
        for key2response in sorted(keys2response):
            print(key2response, ' : ', response4getinfosampler[key2response] ['NORMALIZATION'], ' ', response4getinfosampler[key2response] ['ADDRESSINGMODE'], ' ', response4getinfosampler[key2response] ['FILTERINGMODE'])
            # APU  :  CL_TRUE   CL_ADDRESS_MIRRORED_REPEAT   CL_FILTER_NEAREST
            # GPU  :  CL_TRUE   CL_ADDRESS_MIRRORED_REPEAT   CL_FILTER_NEAREST
            # ZPU  :  CL_TRUE   CL_ADDRESS_MIRRORED_REPEAT   CL_FILTER_NEAREST
    except:
        print('(Step 12Z/700) OF SAMPLER4XI5TEST *** FAILED TO GET SELECTED SAMPLER INFO OF XI DEVICE ', time4xi())  
                                
    
    # ---------------------------------------------------------------------------------------------
    # (13) REFERENCE COUNT FOR TWO PROCESSING UNITS RETAINED BY INCREMENTING COUNT WITH 1             
    # ---------------------------------------------------------------------------------------------    
    task4retain2sampler  = {}
    task4retain2sampler ['APU']  = {}
    task4retain2sampler ['APU'] ['COUNT2REFERENCE'] = 1
    task4retain2sampler ['GPU']  = {}
    task4retain2sampler ['GPU'] ['COUNT2REFERENCE'] = 1    
    task4retain2sampler ['ZPU']  = {}
    task4retain2sampler ['ZPU'] ['COUNT2REFERENCE'] = 1    
     
    response4retainsampler = {}
    print('(Step 13A/700) OF SAMPLER4XI5TEST - TRYING TO RETAIN SAMPLER OF XI DEVICE ', time4xi())   
    try:                               
        response4retainsampler = retain2sampler4xi(task4retain2sampler)                                                                                                 
        print('(Step 13B/700) OF SAMPLER4XI5TEST - RESPONSE4RETAIN2DSAMPLER : ', time4xi())                         
        keys2response = response4retainsampler.keys()
        for key2response in sorted(keys2response):
            print(key2response, ' : ', response4retainsampler[key2response] ['COUNT2REFERENCE'] )
            # APU  :  1
            # BPU  :  1
            # CPU  :  1
            # DPU  :  1
            # EPU  :  1
            # FPU  :  1
            # GPU  :  2
            # HPU  :  1
            # IPU  :  1
            # JPU  :  1
            # KPU  :  1
            # LPU  :  1
            # MPU  :  1
            # NPU  :  1
            # OPU  :  1
            # PPU  :  1
            # QPU  :  1
            # RPU  :  1
            # SPU  :  1
            # TPU  :  1
            # UPU  :  1
            # VPU  :  1
            # WPU  :  1
            # XPU  :  1
            # YPU  :  1
            # ZPU  :  1 
                   
    except:
        print('(Step 13Z/700) OF SAMPLER4XI5TEST *** FAILED TO RETAIN SAMPLER OF XI DEVICE ', time4xi()) 
    
           

    # ---------------------------------------------------------------------------------------------
    # (14) SAMPLER CALLBACK            
    # ---------------------------------------------------------------------------------------------    
    print('(Step 14B/700) OF SAMPLER4XI5TEST - TRYING TO SET SAMPLER CALLBACK OF XI DEVICE ', time4xi())     
    try:                               
        task4callback2sampler  = {}
        for key2pu in keys2pu:
            task4callback2sampler[key2pu]  = {}
        response4setcallback2sampler = set2samplercallback4xi(task4callback2sampler) 
        key2response = response4setcallback2sampler.keys()
        for key2response in sorted(keys2response):
            print(key2response, ' : ', response4setcallback2sampler[key2response] ['CALLBACK'] )
            # APU  :  <function trace2sampler4apu at 0x000000000431B2C8>
            # BPU  :  <function trace2sampler4bpu at 0x0000000004387348>
            # CPU  :  <function trace2sampler4cpu at 0x00000000043E3148>
            # DPU  :  <function trace2sampler4dpu at 0x0000000004431EC8>
            # EPU  :  <function trace2sampler4epu at 0x0000000004478CC8>
            # FPU  :  <function trace2sampler4fpu at 0x00000000044D4AC8>
            # GPU  :  <function trace2sampler4gpu at 0x00000000045268C8>
            # HPU  :  <function trace2sampler4hpu at 0x000000000459F6C8>
            # IPU  :  <function trace2sampler4ipu at 0x00000000046154C8>
            # JPU  :  <function trace2sampler4jpu at 0x000000000465D2C8>
            # KPU  :  <function trace2sampler4kpu at 0x00000000046D20C8>
            # LPU  :  <function trace2sampler4lpu at 0x0000000004718E48>
            # MPU  :  <function trace2sampler4mpu at 0x000000000476CC48>
            # NPU  :  <function trace2sampler4npu at 0x00000000047D4A48>
            # OPU  :  <function trace2sampler4opu at 0x000000000483E848>
            # PPU  :  <function trace2sampler4ppu at 0x00000000048AE648>
            # QPU  :  <function trace2sampler4qpu at 0x0000000004901448>
            # RPU  :  <function trace2sampler4rpu at 0x0000000004999248>
            # SPU  :  <function trace2sampler4spu at 0x0000000004A22048>
            # TPU  :  <function trace2sampler4tpu at 0x0000000004A4CDC8>
            # UPU  :  <function trace2sampler4upu at 0x0000000004AABBC8>
            # VPU  :  <function trace2sampler4vpu at 0x0000000004B1C9C8>
            # WPU  :  <function trace2sampler4wpu at 0x0000000004BD75C8>
            # XPU  :  <function trace2sampler4xpu at 0x0000000004B7F7C8>
            # YPU  :  <function trace2sampler4ypu at 0x0000000004C3A3C8>
            # ZPU  :  <function trace2sampler4zpu at 0x0000000004C8F1C8>                                                  
    except:
        print('(Step 14Z2/700) OF SAMPLER4XI5TEST *** FAILED TO SET SAMPLER CALLBACK OF XI DEVICE ', time4xi())  
    
    print('(Step 14C/700) OF SAMPLER4XI5TEST - TRYING TO VERIFY XI KNOWLEDGEBASE ', time4xi())  
    try:                               
        task4getinfo2sampler = {}
        task4getinfo2sampler ['APU'] = {}
        task4getinfo2sampler ['APU'] ['CALLBACK'] = 'YES'
        task4getinfo2sampler ['GPU'] = {}
        task4getinfo2sampler ['GPU'] ['CALLBACK'] = 'YES'
        task4getinfo2sampler ['XPU'] = {}
        task4getinfo2sampler ['XPU'] ['CALLBACK'] = 'YES'          
        task4getinfo2sampler ['ZPU'] = {}
        task4getinfo2sampler ['ZPU'] ['CALLBACK'] = 'YES'    
                           
        response4getinfosampler = get2samplerinfo4xi (task4getinfo2sampler)                                                                                             
        keys2response = response4getinfosampler.keys()
        for key2response in sorted(keys2response):
            print(key2response, ' : ', response4getinfosampler[key2response] ['CALLBACK'] )
            # APU  :  <function trace2sampler4apu at 0x000000000431B2C8>
            # GPU  :  <function trace2sampler4gpu at 0x00000000045268C8>
            # XPU  :  <function trace2sampler4xpu at 0x0000000004B7F7C8>
            # ZPU  :  <function trace2sampler4zpu at 0x0000000004C8F1C8>
            
    except:
        print('(Step 14Z3/700) OF SAMPLER4XI5TEST *** FAILED TO VERIFY XI KNOWLEDGEBASE ', time4xi())         
        
    print("JATKA")                                                                             
    # ---------------------------------------------------------------------------------------------
    # PHASE I: TRACE FUNCTION TESTS                    
    # ---------------------------------------------------------------------------------------------    
    print('(Step 15A/25) OF SAMPLER4XI5TEST - TRYING TO TRACE XI: ', time4xi()) 
    try:                               
        task4trace2sampler  = {}
        for key2pu in keys2pu:
            task4trace2sampler[key2pu]  = {}
        response4trace2sampler = trace2sampler4xi(task4trace2sampler)  
        key2response = response4trace2sampler.keys()
        for key2response in sorted(keys2response):
            try:
                KB4Detail = response4trace2sampler[key2response]
                keys2detail = KB4Detail.keys()
                for key2detail in keys2detail:
                    print(key2response, ': ',key2detail, ' ', response4trace2sampler[key2response] [key2detail])
                    # APU :  MESSAGE   {(Step 2Z0/33) failed; trace2sampler4apu-failed {}; time: 22:04:51 11/09/11 Pacific Standard Time}
                    # APU :  CLASS   trace2sampler4apu
                    # APU :  METHOD   trace2sampler4apu
                    # GPU :  MESSAGE   {(Step 2Z0/33) failed; trace2sampler4gpu-failed {}; time: 22:04:51 11/09/11 Pacific Standard Time}
                    # GPU :  CLASS   trace2sampler4gpu
                    # GPU :  METHOD   trace2sampler4gpu
                    # XPU :  MESSAGE   {(Step 2Z0/33) failed; trace2sampler4xpu-failed {}; time: 22:04:51 11/09/11 Pacific Standard Time}
                    # XPU :  CLASS   trace2sampler4xpu
                    # XPU :  METHOD   trace2sampler4xpu
                    # ZPU :  MESSAGE   {(Step 2Z0/33) failed; trace2sampler4zpu-failed {}; time: 22:04:51 11/09/11 Pacific Standard Time}
                    # ZPU :  CLASS   trace2sampler4zpu
                    # ZPU :  METHOD   trace2sampler4zpu               
            except:
                print('(Step 15Z1/25) OF SAMPLER4XI5TEST *** FAILED TO TRACE XI: ', time4xi())        
                                                       
    except:
        print('(Step 15Z2/25) OF SAMPLER4XI5TEST *** FAILED TO TRACE XI: ', time4xi()) 
                                                                                                          

                                                                                                                                                       
    # ---------------------------------------------------------------------------------------------
    # PHASE II: CLASS TESTS - CREATE OBJECT                         
    # ---------------------------------------------------------------------------------------------
    print('(Step 105A/700) OF SAMPLER4XI5TEST - CREATING SAMPLER4XI OBJECT ', time4xi())     
    #
    try:
        # ---------------------------------------------------------------------------------------------
        # CREATE OBJECT                        
        # ---------------------------------------------------------------------------------------------        
        samplerobject2xi = Sampler4Xi()
        print('(Step 105B/700) OF SAMPLER4XI5TEST - CREATED SAMPLER4XI OBJECT: ', samplerobject2xi)                                  
        # <sampler4xi.Sampler4Xi object at 0x00000000050F4A90> 
        
    except:
        print('(Step 105Z/700) OF SAMPLER4XI5TEST *** FAILED TO CREATE SAMPLER4XI OBJECT')
    
    # ---------------------------------------------------------------------------------------------
    # PHASE II: CLASS TESTS - GET SAMPLER INFO WITH METHOD              
    # ---------------------------------------------------------------------------------------------          
    print('(Step 106A1/700) OF SAMPLER4XI5TEST - TRYING TO GET SAMPLER INFO WITH METHOD ', time4xi())    
    try: 
        task4getinfo2sampler = {}
        for key2pu in keys2pu:
            if KB2CC [key2pu] == 'ACK':
                task4getinfo2sampler [key2pu]  = {}
                task4getinfo2sampler [key2pu] ['NORMALIZATION']   = 'YES'
                task4getinfo2sampler [key2pu] ['ADDRESSINGMODE']  = 'YES'
                task4getinfo2sampler [key2pu] ['FILTERINGMODE']   = 'YES'  
               
        response4get2samplerinfo = samplerobject2xi.get2samplerinfo(task4getinfo2sampler)                                 
                                               
        keys2response = response4get2samplerinfo.keys()
        for key2response in sorted(keys2response):
            print(key2response, ' : ', response4get2samplerinfo[key2response] ['NORMALIZATION'], ' ',  response4get2samplerinfo[key2response] ['ADDRESSINGMODE'], ' ', response4get2samplerinfo[key2response] ['FILTERINGMODE'])
            # APU  :  CL_TRUE   CL_ADDRESS_MIRRORED_REPEAT   CL_FILTER_NEAREST
            # GPU  :  CL_TRUE   CL_ADDRESS_MIRRORED_REPEAT   CL_FILTER_NEAREST
            # ZPU  :  CL_TRUE   CL_ADDRESS_MIRRORED_REPEAT   CL_FILTER_NEAREST
            
    except:
        print('(Step 106Z1/700) OF SAMPLER4XI5TEST *** FAILED TO GET SAMPLER INFO WITH METHOD ', time4xi()) 
    
 
   
    # ---------------------------------------------------------------------------------------------
    # PHASE II: CLASS TESTS - SET METHOD            
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 103A/700) OF SAMPLER4XI5TEST - TRYING TO SET SAMPLER ', time4xi())
    print('=' *33)       
    # 
          
    # ---------------------------------------------------------------------------------------------
    # (104) INITIALIZE TASK DICTIONARY AND GET PLATFORM                         
    # ---------------------------------------------------------------------------------------------            
    task4set2sampler = {}
    print('(Step 104A/700) OF SAMPLER4XI5TEST - TRYING TO GET PLATFORMIDS4XI', time4xi())
    try:
        platform2xi = get2platformids4xi()
        print('(Step 104V/33) OF SAMPLER4XI5TEST - GOT PLATFORMIDS4XI', platform2xi) 
        # {'list2platforms': ['DragonXi'], 'ack2return': ' 2C-2E-2F-2G-', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}
         
    except:
        print('(Step 104Z/33) OF SAMPLER4XI5TEST *** FAILED TO GET PLATFORMIDS4XI', time4xi())  

    # ---------------------------------------------------------------------------------------------
    # (105) DEFINE CONTEXT - REQUIRED                          
    # ---------------------------------------------------------------------------------------------         
    print('=' *33)          
    print('(Step 105A/700) OF SAMPLER4XI5TEST - TRYING TO CREATE CONTEXT4XI ', time4xi())    
    print('=' *33)        
    try:
        context2xi = create2context4xi()                                                                            
        keys2context = context2xi.keys()
        for key2context in sorted(keys2context):
            print(key2context, device2xi[key2context])
            # APU {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK' ...
            # ...
            # ZPU {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM': '0000000001509568', 'PROFILING2QUEUE': 'ACK' ...   
    except:
        print('(Step 105Z/700) OF SAMPLER4XI5TEST *** FAILED TO CREATE CONTEXT4XI', time4xi()) 
    
    # ---------------------------------------------------------------------------------------------
    # (106) DEFINE DEVICE - EXTRA                      
    # ---------------------------------------------------------------------------------------------         
    print('(Step 106A/33) OF SAMPLER4XI5TEST - TRYING TO INITIALIZE DEVICE4XI ', time4xi())   
    try:
        device2xi = init2device4xi()                                                                                
        keys2device = device2xi.keys()
        for key2device in sorted(keys2device):
            print(key2device, device2xi[key2device])
            # APU {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM' ...
            # ...
            # ZPU {'RESOLUTION2TIMER4PROFILING': 318, 'ID2PLATFORM' ... 
    except:
        print('(Step 106Z/33) OF SAMPLER4XI5TEST *** FAILED TO INITIALIZE DEVICE4XI', time4xi())   
                      
   # ---------------------------------------------------------------------------------------------
    # (107) CREATE XI COMMANDQUEUE                
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 107A/700) OF SAMPLER4XI5TEST - TRYING TO CREATE COMMANDQUEUE ', time4xi())    
    print('=' *33)        
    try:
        queue4command = create2commandqueue4xi()                                                                            
        keys2commandqueue = queue4command.keys()
        for key2commandqueue in sorted(keys2commandqueue):
            print(key2commandqueue, queue4command[key2commandqueue])
            # APU {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': ...
            # ...
            # ZPU {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0, 'DATA2CALLBACK': {'MESSAGE': ...
              
    except:
        print('(Step 107Z/700) OF SAMPLER4XI5TEST *** FAILED TO CREATE COMMANDQUEUE', time4xi())
        
    # -------------------------------------------------------------------------------------------------    
    # (108) INITIALIZE TASK4SET2SAMPLER FOR PROCESSING UNITS              
    # -------------------------------------------------------------------------------------------------          
    print('(Step 108A/700) OF SAMPLER4XI5TEST - TRYING TO INITIALIZE TASK4SET2SAMPLER FOR PROCESSING UNITS ', time4xi())
    try:
        for key2setsampler in sorted(keys2setsampler):
            task4set2sampler [key2setsampler] = {}
            print(key2setsampler, task4set2sampler [key2setsampler] )
    except:
        print('(Step 108Z/700) OF SAMPLER4XI5TEST *** FAILED TO INITIALIZE TASK4SET2SAMPLER FOR PROCESSING UNITS ', time4xi()) 
    
    # -------------------------------------------------------------------------------------------------    
    # (109) SET CONTEXT OF TASK4SET2SAMPLER FOR PROCESSING UNITS              
    # -------------------------------------------------------------------------------------------------          
    print('(Step 109A/700) OF SAMPLER4XI5TEST - TRYING TO SET CONTEXT OF TASK4SET2SAMPLER FOR PROCESSING UNITS ', time4xi())
    try:
        for key2setsampler in sorted(keys2setsampler):
            task4set2sampler [key2setsampler] ['CONTEXT'] = context2xi [key2setsampler] 
            print(key2setsampler, ' CONTEXT: ', task4set2sampler [key2setsampler] ['CONTEXT'])
            # 
                 
    except:
        print('(Step 109Z/700) OF SAMPLER4XI5TEST *** FAILED TO SET CONTEXT OF TASK4SET2SAMPLER FOR PROCESSING UNITS ', time4xi()) 
    # -------------------------------------------------------------------------------------------------    
    # (110) SET DEVICE OF TASK4SET2SAMPLER FOR PROCESSING UNITS              
    # -------------------------------------------------------------------------------------------------          
    print('(Step 110A/700) OF SAMPLER4XI5TEST - TRYING TO SET DEVICE OF TASK4SET2SAMPLER FOR PROCESSING UNITS ', time4xi())
    try:
        for key2setsampler in sorted(keys2setsampler):        
            task4set2sampler [key2setsampler] ['DEVICE'] = device2xi [key2setsampler] 
            print(key2setsampler, 'DEVICE:' , task4set2sampler [key2setsampler] ['DEVICE'])
            # 
             
    except:
        print('(Step 110Z/700) OF SAMPLER4XI5TEST *** FAILED TO SET DEVICE OF TASK4SET2SAMPLER FOR PROCESSING UNITS ', time4xi()) 
    # -------------------------------------------------------------------------------------------------    
    # (111) SET PROPERTIES OF TASK4SET2SAMPLER FOR PROCESSING UNITS              
    # -------------------------------------------------------------------------------------------------          
    print('(Step 111A/700) OF SAMPLER4XI5TEST - TRYING TO SET PROPERTIES FOR PROCESSING UNITS ', time4xi())
    try:
        for key2setsampler in sorted(keys2setsampler):        
            task4set2sampler [key2setsampler] ['PROPERTIES'] = None
            task4set2sampler [key2setsampler] ['CODE2ERROR'] = 0  
            print(key2setsampler, 'PROPERTIES: ', task4set2sampler [key2setsampler] ['PROPERTIES'], ' CODE2ERROR: ', task4set2sampler [key2setsampler] ['CODE2ERROR'])
            # 
             
    except:
        print('(Step 111Z/700) OF SAMPLER4XI5TEST *** FAILED TO SET PROPERTIES OF TASK4SET2SAMPLER FOR PROCESSING UNITS ', time4xi())                              
    # -------------------------------------------------------------------------------------------------    
    # (112) SET QUEUE OF TASK4SET2SAMPLER FOR PROCESSING UNITS              
    # -------------------------------------------------------------------------------------------------          
    print('(Step 112A/700) OF SAMPLER4XI5TEST - TRYING TO SET QUEUE FOR PROCESSING UNITS ', time4xi())
    try:
        for key2setsampler in sorted(keys2setsampler):        
            task4set2sampler [key2setsampler] ['QUEUE'] = Queue4Xi()
            print(key2setsampler, ' QUEUE: ', task4set2sampler [key2setsampler] ['QUEUE'])
            # APU  QUEUE:  <queue4xi.Queue4Xi object at 0x0000000005DFE4A8>
            # BPU  QUEUE:  <queue4xi.Queue4Xi object at 0x0000000005DFE518>
            # CPU  QUEUE:  <queue4xi.Queue4Xi object at 0x0000000005DFE668>
            # DPU  QUEUE:  <queue4xi.Queue4Xi object at 0x0000000005DFEDA0>
            # EPU  QUEUE:  <queue4xi.Queue4Xi object at 0x0000000005DFEEB8>
            # FPU  QUEUE:  <queue4xi.Queue4Xi object at 0x0000000005DFEFD0>
            # GPU  QUEUE:  <queue4xi.Queue4Xi object at 0x0000000005E01128>
            # HPU  QUEUE:  <queue4xi.Queue4Xi object at 0x0000000005E01240>
            # IPU  QUEUE:  <queue4xi.Queue4Xi object at 0x0000000005E01358>
            # JPU  QUEUE:  <queue4xi.Queue4Xi object at 0x0000000005E01470>
            # KPU  QUEUE:  <queue4xi.Queue4Xi object at 0x0000000005E01588>
            # LPU  QUEUE:  <queue4xi.Queue4Xi object at 0x0000000005E016A0>
            # MPU  QUEUE:  <queue4xi.Queue4Xi object at 0x0000000005E017B8>
            # NPU  QUEUE:  <queue4xi.Queue4Xi object at 0x0000000005E018D0>
            # OPU  QUEUE:  <queue4xi.Queue4Xi object at 0x0000000005E019E8>
            # PPU  QUEUE:  <queue4xi.Queue4Xi object at 0x0000000005E01B00>
            # QPU  QUEUE:  <queue4xi.Queue4Xi object at 0x0000000005E01C18>
            # RPU  QUEUE:  <queue4xi.Queue4Xi object at 0x0000000005E01D30>
            # SPU  QUEUE:  <queue4xi.Queue4Xi object at 0x0000000005E01E48>
            # TPU  QUEUE:  <queue4xi.Queue4Xi object at 0x0000000005E01F60>
            # UPU  QUEUE:  <queue4xi.Queue4Xi object at 0x0000000005E080B8>
            # VPU  QUEUE:  <queue4xi.Queue4Xi object at 0x0000000005E081D0>
            # WPU  QUEUE:  <queue4xi.Queue4Xi object at 0x0000000005E082E8>
            # XPU  QUEUE:  <queue4xi.Queue4Xi object at 0x0000000005E08400>
            # YPU  QUEUE:  <queue4xi.Queue4Xi object at 0x0000000005E08518>
            # ZPU  QUEUE:  <queue4xi.Queue4Xi object at 0x0000000005E08630>
             
    except:
        print('(Step 112Z/700) OF SAMPLER4XI5TEST *** FAILED TO SET QUEUE OF TASK4SET2SAMPLER FOR PROCESSING UNITS ', time4xi())
    # -------------------------------------------------------------------------------------------------    
    # (113) SET PIPE OF TASK4SET2SAMPLER FOR PROCESSING UNITS              
    # -------------------------------------------------------------------------------------------------          
    print('(Step 113A/700) OF SAMPLER4XI5TEST - TRYING TO SET PIPE FOR PROCESSING UNITS ', time4xi())
    try:
        for key2setsampler in sorted(keys2setsampler):        
            task4set2sampler  [key2setsampler] ['PIPE'] = Pipe4Xi() 
            print(key2setsampler, ' PIPE: ', task4set2sampler  [key2setsampler] ['PIPE'])
            # APU  PIPE:  (<read-write PipeConnection, handle 8864>, <read-write PipeConnection, handle 8868>)
            # BPU  PIPE:  (<read-write PipeConnection, handle 8872>, <read-write PipeConnection, handle 8876>)
            # CPU  PIPE:  (<read-write PipeConnection, handle 8880>, <read-write PipeConnection, handle 8884>)
            # DPU  PIPE:  (<read-write PipeConnection, handle 8888>, <read-write PipeConnection, handle 8892>)
            # EPU  PIPE:  (<read-write PipeConnection, handle 8896>, <read-write PipeConnection, handle 8900>)
            # FPU  PIPE:  (<read-write PipeConnection, handle 8904>, <read-write PipeConnection, handle 8908>)
            # GPU  PIPE:  (<read-write PipeConnection, handle 8912>, <read-write PipeConnection, handle 8916>)
            # HPU  PIPE:  (<read-write PipeConnection, handle 8920>, <read-write PipeConnection, handle 8924>)
            # IPU  PIPE:  (<read-write PipeConnection, handle 8928>, <read-write PipeConnection, handle 8932>)
            # JPU  PIPE:  (<read-write PipeConnection, handle 8936>, <read-write PipeConnection, handle 8940>)
            # KPU  PIPE:  (<read-write PipeConnection, handle 8944>, <read-write PipeConnection, handle 8948>)
            # LPU  PIPE:  (<read-write PipeConnection, handle 8952>, <read-write PipeConnection, handle 8956>)
            # MPU  PIPE:  (<read-write PipeConnection, handle 8960>, <read-write PipeConnection, handle 8964>)
            # NPU  PIPE:  (<read-write PipeConnection, handle 8968>, <read-write PipeConnection, handle 8972>)
            # OPU  PIPE:  (<read-write PipeConnection, handle 8976>, <read-write PipeConnection, handle 8980>)
            # PPU  PIPE:  (<read-write PipeConnection, handle 8984>, <read-write PipeConnection, handle 8988>)
            # QPU  PIPE:  (<read-write PipeConnection, handle 8992>, <read-write PipeConnection, handle 8996>)
            # RPU  PIPE:  (<read-write PipeConnection, handle 9000>, <read-write PipeConnection, handle 9004>)
            # SPU  PIPE:  (<read-write PipeConnection, handle 9008>, <read-write PipeConnection, handle 9012>)
            # TPU  PIPE:  (<read-write PipeConnection, handle 9016>, <read-write PipeConnection, handle 9020>)
            # UPU  PIPE:  (<read-write PipeConnection, handle 9024>, <read-write PipeConnection, handle 9028>)
            # VPU  PIPE:  (<read-write PipeConnection, handle 9032>, <read-write PipeConnection, handle 9036>)
            # WPU  PIPE:  (<read-write PipeConnection, handle 9040>, <read-write PipeConnection, handle 9044>)
            # XPU  PIPE:  (<read-write PipeConnection, handle 9048>, <read-write PipeConnection, handle 9052>)
            # YPU  PIPE:  (<read-write PipeConnection, handle 9056>, <read-write PipeConnection, handle 9060>)
            # ZPU  PIPE:  (<read-write PipeConnection, handle 9064>, <read-write PipeConnection, handle 9068>)
             
    except:
        print('(Step 113Z/700) OF SAMPLER4XI5TEST *** FAILED TO SET PIPE OF TASK4SET2SAMPLER FOR PROCESSING UNITS ', time4xi()) 
    # -------------------------------------------------------------------------------------------------    
    # (114) SET NORMALIZATION OF TASK4SET2SAMPLER FOR PROCESSING UNITS              
    # -------------------------------------------------------------------------------------------------          
    print('(Step 114A/700) OF SAMPLER4XI5TEST - TRYING TO SET NORMALIZATION FOR PROCESSING UNITS ', time4xi()) 
    try:
        for key2setsampler in sorted(keys2setsampler):        
            task4set2sampler  [key2setsampler] ['NORMALIZATION'] = 'CL_FALSE'
            print(key2setsampler, ' NORMALIZATION: ', task4set2sampler  [key2setsampler] ['NORMALIZATION'])
            # APU  NORMALIZATION:  CL_FALSE
            # BPU  NORMALIZATION:  CL_FALSE
            # CPU  NORMALIZATION:  CL_FALSE
            # DPU  NORMALIZATION:  CL_FALSE
            # EPU  NORMALIZATION:  CL_FALSE
            # FPU  NORMALIZATION:  CL_FALSE
            # GPU  NORMALIZATION:  CL_FALSE
            # HPU  NORMALIZATION:  CL_FALSE
            # IPU  NORMALIZATION:  CL_FALSE
            # JPU  NORMALIZATION:  CL_FALSE
            # KPU  NORMALIZATION:  CL_FALSE
            # LPU  NORMALIZATION:  CL_FALSE
            # MPU  NORMALIZATION:  CL_FALSE
            # NPU  NORMALIZATION:  CL_FALSE
            # OPU  NORMALIZATION:  CL_FALSE
            # PPU  NORMALIZATION:  CL_FALSE
            # QPU  NORMALIZATION:  CL_FALSE
            # RPU  NORMALIZATION:  CL_FALSE
            # SPU  NORMALIZATION:  CL_FALSE
            # TPU  NORMALIZATION:  CL_FALSE
            # UPU  NORMALIZATION:  CL_FALSE
            # VPU  NORMALIZATION:  CL_FALSE
            # WPU  NORMALIZATION:  CL_FALSE
            # XPU  NORMALIZATION:  CL_FALSE
            # YPU  NORMALIZATION:  CL_FALSE
            # ZPU  NORMALIZATION:  CL_FALSE
             
    except:
        print('(Step 114Z/700) OF SAMPLER4XI5TEST *** FAILED TO SET NORMALIZATION OF TASK4SET2SAMPLER FOR PROCESSING UNITS ', time4xi()) 
    # -------------------------------------------------------------------------------------------------    
    # (115) SET ADDRESSINGMODE OF TASK4SET2SAMPLER FOR PROCESSING UNITS              
    # -------------------------------------------------------------------------------------------------          
    print('(Step 115A/700) OF SAMPLER4XI5TEST - TRYING TO SET ADDRESSINGMODE FOR PROCESSING UNITS ', time4xi())
    try:
        for key2setsampler in sorted(keys2setsampler):        
            task4set2sampler  [key2setsampler] ['ADDRESSINGMODE'] = 'CL_ADDRESS_CLAMP_TO_EDGE' 
            print(key2setsampler, ' ADDRESSINGMODE: ', task4set2sampler  [key2setsampler] ['ADDRESSINGMODE'])
            # APU  ADDRESSINGMODE:  CL_ADDRESS_CLAMP_TO_EDGE
            # BPU  ADDRESSINGMODE:  CL_ADDRESS_CLAMP_TO_EDGE
            # CPU  ADDRESSINGMODE:  CL_ADDRESS_CLAMP_TO_EDGE
            # DPU  ADDRESSINGMODE:  CL_ADDRESS_CLAMP_TO_EDGE
            # EPU  ADDRESSINGMODE:  CL_ADDRESS_CLAMP_TO_EDGE
            # FPU  ADDRESSINGMODE:  CL_ADDRESS_CLAMP_TO_EDGE
            # GPU  ADDRESSINGMODE:  CL_ADDRESS_CLAMP_TO_EDGE
            # HPU  ADDRESSINGMODE:  CL_ADDRESS_CLAMP_TO_EDGE
            # IPU  ADDRESSINGMODE:  CL_ADDRESS_CLAMP_TO_EDGE
            # JPU  ADDRESSINGMODE:  CL_ADDRESS_CLAMP_TO_EDGE
            # KPU  ADDRESSINGMODE:  CL_ADDRESS_CLAMP_TO_EDGE
            # LPU  ADDRESSINGMODE:  CL_ADDRESS_CLAMP_TO_EDGE
            # MPU  ADDRESSINGMODE:  CL_ADDRESS_CLAMP_TO_EDGE
            # NPU  ADDRESSINGMODE:  CL_ADDRESS_CLAMP_TO_EDGE
            # OPU  ADDRESSINGMODE:  CL_ADDRESS_CLAMP_TO_EDGE
            # PPU  ADDRESSINGMODE:  CL_ADDRESS_CLAMP_TO_EDGE
            # QPU  ADDRESSINGMODE:  CL_ADDRESS_CLAMP_TO_EDGE
            # RPU  ADDRESSINGMODE:  CL_ADDRESS_CLAMP_TO_EDGE
            # SPU  ADDRESSINGMODE:  CL_ADDRESS_CLAMP_TO_EDGE
            # TPU  ADDRESSINGMODE:  CL_ADDRESS_CLAMP_TO_EDGE
            # UPU  ADDRESSINGMODE:  CL_ADDRESS_CLAMP_TO_EDGE
            # VPU  ADDRESSINGMODE:  CL_ADDRESS_CLAMP_TO_EDGE
            # WPU  ADDRESSINGMODE:  CL_ADDRESS_CLAMP_TO_EDGE
            # XPU  ADDRESSINGMODE:  CL_ADDRESS_CLAMP_TO_EDGE
            # YPU  ADDRESSINGMODE:  CL_ADDRESS_CLAMP_TO_EDGE
            # ZPU  ADDRESSINGMODE:  CL_ADDRESS_CLAMP_TO_EDGE
             
    except:
        print('(Step 115Z/700) OF SAMPLER4XI5TEST *** FAILED TO SET ADDRESSINGMODE OF TASK4SET2SAMPLER FOR PROCESSING UNITS ', time4xi()) 
    # -------------------------------------------------------------------------------------------------    
    # (116) SET FILTERINGMODE OF TASK4SET2SAMPLER FOR PROCESSING UNITS              
    # -------------------------------------------------------------------------------------------------          
    print('(Step 116A/700) OF SAMPLER4XI5TEST - TRYING TO SET FILTERINGMODE FOR PROCESSING UNITS ', time4xi())
    try:
        for key2setsampler in sorted(keys2setsampler):        
            task4set2sampler  [key2setsampler] ['FILTERINGMODE'] = 'CL_FILTER_LINEAR' 
            print(key2setsampler, ' FILTERINGMODE: ', task4set2sampler  [key2setsampler] ['FILTERINGMODE'])
            # APU  FILTERINGMODE:  CL_FILTER_LINEAR
            # BPU  FILTERINGMODE:  CL_FILTER_LINEAR
            # CPU  FILTERINGMODE:  CL_FILTER_LINEAR
            # DPU  FILTERINGMODE:  CL_FILTER_LINEAR
            # EPU  FILTERINGMODE:  CL_FILTER_LINEAR
            # FPU  FILTERINGMODE:  CL_FILTER_LINEAR
            # GPU  FILTERINGMODE:  CL_FILTER_LINEAR
            # HPU  FILTERINGMODE:  CL_FILTER_LINEAR
            # IPU  FILTERINGMODE:  CL_FILTER_LINEAR
            # JPU  FILTERINGMODE:  CL_FILTER_LINEAR
            # KPU  FILTERINGMODE:  CL_FILTER_LINEAR
            # LPU  FILTERINGMODE:  CL_FILTER_LINEAR
            # MPU  FILTERINGMODE:  CL_FILTER_LINEAR
            # NPU  FILTERINGMODE:  CL_FILTER_LINEAR
            # OPU  FILTERINGMODE:  CL_FILTER_LINEAR
            # PPU  FILTERINGMODE:  CL_FILTER_LINEAR
            # QPU  FILTERINGMODE:  CL_FILTER_LINEAR
            # RPU  FILTERINGMODE:  CL_FILTER_LINEAR
            # SPU  FILTERINGMODE:  CL_FILTER_LINEAR
            # TPU  FILTERINGMODE:  CL_FILTER_LINEAR
            # UPU  FILTERINGMODE:  CL_FILTER_LINEAR
            # VPU  FILTERINGMODE:  CL_FILTER_LINEAR
            # WPU  FILTERINGMODE:  CL_FILTER_LINEAR
            # XPU  FILTERINGMODE:  CL_FILTER_LINEAR
            # YPU  FILTERINGMODE:  CL_FILTER_LINEAR
            # ZPU  FILTERINGMODE:  CL_FILTER_LINEAR
             
    except:
        print('(Step 116Z/700) OF SAMPLER4XI5TEST *** FAILED TO SET FILTERINGMODE OF TASK4SET2SAMPLER FOR PROCESSING UNITS ', time4xi())                                                                            
    # ---------------------------------------------------------------------------------------------
    # PHASE II: CLASS TESTS - SET SAMPLER WITH METHOD               
    # ---------------------------------------------------------------------------------------------     
       
    response4setsampler = {} 
    print('(Step 114A/700) OF SAMPLER4XI5TEST - TRYING TO SET SAMPLER4XI ', time4xi())   
    try:                               
        response4setsampler = samplerobject2xi.set2sampler(task4set2sampler)                                                                                                         
                                                                                      
        print('(Step 114B/700) OF SAMPLER4XI5TEST - SET SAMPLER4XI ', time4xi())
        keys2response = response4setsampler.keys()
        for key2response in sorted(keys2response):
            print(key2response, ' : ', response4setsampler[key2response] ['NORMALIZATION'], ' ', response4setsampler[key2response] ['ADDRESSINGMODE'],  ' ', response4setsampler[key2response] ['FILTERINGMODE'] )
            # APU  :  CL_TRUE   CL_ADDRESS_MIRRORED_REPEAT   CL_FILTER_NEAREST
            # BPU  :  CL_TRUE   CL_ADDRESS_MIRRORED_REPEAT   CL_FILTER_NEAREST
            # CPU  :  CL_TRUE   CL_ADDRESS_MIRRORED_REPEAT   CL_FILTER_NEAREST
            # DPU  :  CL_TRUE   CL_ADDRESS_MIRRORED_REPEAT   CL_FILTER_NEAREST
            # EPU  :  CL_TRUE   CL_ADDRESS_MIRRORED_REPEAT   CL_FILTER_NEAREST
            # FPU  :  CL_TRUE   CL_ADDRESS_MIRRORED_REPEAT   CL_FILTER_NEAREST
            # GPU  :  CL_TRUE   CL_ADDRESS_MIRRORED_REPEAT   CL_FILTER_NEAREST
            # HPU  :  CL_TRUE   CL_ADDRESS_MIRRORED_REPEAT   CL_FILTER_NEAREST
            # IPU  :  CL_TRUE   CL_ADDRESS_MIRRORED_REPEAT   CL_FILTER_NEAREST
            # JPU  :  CL_TRUE   CL_ADDRESS_MIRRORED_REPEAT   CL_FILTER_NEAREST
            # KPU  :  CL_TRUE   CL_ADDRESS_MIRRORED_REPEAT   CL_FILTER_NEAREST
            # LPU  :  CL_TRUE   CL_ADDRESS_MIRRORED_REPEAT   CL_FILTER_NEAREST
            # MPU  :  CL_TRUE   CL_ADDRESS_MIRRORED_REPEAT   CL_FILTER_NEAREST
            # NPU  :  CL_TRUE   CL_ADDRESS_MIRRORED_REPEAT   CL_FILTER_NEAREST
            # OPU  :  CL_TRUE   CL_ADDRESS_MIRRORED_REPEAT   CL_FILTER_NEAREST
            # PPU  :  CL_TRUE   CL_ADDRESS_MIRRORED_REPEAT   CL_FILTER_NEAREST
            # QPU  :  CL_TRUE   CL_ADDRESS_MIRRORED_REPEAT   CL_FILTER_NEAREST
            # RPU  :  CL_TRUE   CL_ADDRESS_MIRRORED_REPEAT   CL_FILTER_NEAREST
            # SPU  :  CL_TRUE   CL_ADDRESS_MIRRORED_REPEAT   CL_FILTER_NEAREST
            # TPU  :  CL_TRUE   CL_ADDRESS_MIRRORED_REPEAT   CL_FILTER_NEAREST
            # UPU  :  CL_TRUE   CL_ADDRESS_MIRRORED_REPEAT   CL_FILTER_NEAREST
            # VPU  :  CL_TRUE   CL_ADDRESS_MIRRORED_REPEAT   CL_FILTER_NEAREST
            # WPU  :  CL_TRUE   CL_ADDRESS_MIRRORED_REPEAT   CL_FILTER_NEAREST
            # XPU  :  CL_TRUE   CL_ADDRESS_MIRRORED_REPEAT   CL_FILTER_NEAREST
            # YPU  :  CL_TRUE   CL_ADDRESS_MIRRORED_REPEAT   CL_FILTER_NEAREST
            # ZPU  :  CL_TRUE   CL_ADDRESS_MIRRORED_REPEAT   CL_FILTER_NEAREST
            
        print('(Step 114B/700) OF SAMPLER4XI5TEST - SET SAMPLER4XI ', time4xi())
        # 
             
    except:
        print('(Step 114Z/700) OF SAMPLER4XI5TEST *** FAILED TO SET SAMPLER4XI *** ', time4xi()) 
        
     
                                                                     
    # ---------------------------------------------------------------------------------------------
    # PHASE II: CLASS TESTS - RELEASE SAMPLER WITH METHOD                            
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 121A/700) OF SAMPLER4XI5TEST - RELEASING SAMPLER WITH METHOD ', time4xi())  
    print('=' *33)      
    # 
    task4release2sampler  = {}
    for key2pu in keys2pu:
        task4release2sampler [key2pu] = {} 
        task4release2sampler [key2pu] ['COUNT2REFERENCE'] = 1    
   
    try:
        response4releasesampler = samplerobject2xi.release2sampler(task4release2sampler)
        
        keys2response = response4releasesampler.keys()
        for key2response in sorted(keys2response):
            print(key2response, ' : ', response4releasesampler[key2response] ['COUNT2REFERENCE'])
            # APU  :  0
            # BPU  :  0
            # CPU  :  0
            # DPU  :  0
            # EPU  :  0
            # FPU  :  0
            # GPU  :  0
            # HPU  :  0
            # IPU  :  0
            # JPU  :  0
            # KPU  :  0
            # LPU  :  0
            # MPU  :  0
            # NPU  :  0
            # OPU  :  0
            # PPU  :  0
            # QPU  :  0
            # RPU  :  0
            # SPU  :  0
            # TPU  :  0
            # UPU  :  0
            # VPU  :  0
            # WPU  :  0
            # XPU  :  0
            # YPU  :  0
            # ZPU  :  0
    except:
        print('(Step 121Z/700) OF SAMPLER4XI5TEST *** FAILED TO RELEASE SAMPLER WITH METHOD ', time4xi())  
        
                                                                                   
    # ---------------------------------------------------------------------------------------------
    # PHASE II: CLASS TESTS - RETAIN SAMPLER WITH METHOD                            
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 122A/700) OF SAMPLER4XI5TEST - RETAINING SAMPLER WITH METHOD ', time4xi())
    print('=' *33)      
    task4retain2sampler  = {}
    for key2pu in keys2pu:
        task4retain2sampler [key2pu] = {}
        task4retain2sampler [key2pu] ['COUNT2REFERENCE'] = 1  
    try:
        response4retainsampler = samplerobject2xi.retain2sampler(task4retain2sampler)
        
        keys2response = response4retainsampler.keys()
        for key2response in sorted(keys2response):
            print(key2response, ' : ', response4retainsampler[key2response] ['COUNT2REFERENCE'])
            # APU  :  1
            # BPU  :  1
            # CPU  :  1
            # DPU  :  1
            # EPU  :  1
            # FPU  :  1
            # GPU  :  1
            # HPU  :  1
            # IPU  :  1
            # JPU  :  1
            # KPU  :  1
            # LPU  :  1
            # MPU  :  1
            # NPU  :  1
            # OPU  :  1
            # PPU  :  1
            # QPU  :  1
            # RPU  :  1
            # SPU  :  1
            # TPU  :  1
            # UPU  :  1
            # VPU  :  1
            # WPU  :  1
            # XPU  :  1
            # YPU  :  1
            # ZPU  :  1
    except:
        print('(Step 122Z/700) OF SAMPLER4XI5TEST *** FAILED TO RETAIN SAMPLER  WITH METHOD ', time4xi())
                   
    # ---------------------------------------------------------------------------------------------
    # PHASE II: CLASS TESTS - CREATE AGAIN SAMPLER OBJECT AND USE ITS CREATE METHOD                           
    # ---------------------------------------------------------------------------------------------        
    print('(Step 123A/700) OF SAMPLER4XI5TEST - TRYING TO CREATE SAMPLER for XI ', time4xi()) 
    # 
    try:
        xi2xi = Sampler4Xi()                            
        
                       
        response4createsampler = xi2xi.create2sampler()                                  
        
        keys2response = response4createsampler.keys()
        
        for key2response in sorted(keys2response):
            print(key2response, ' : ', response4createsampler[key2response] ['NORMALIZATION'], response4createsampler[key2response] ['ADDRESSINGMODE'], response4createsampler[key2response] ['FILTERINGMODE'] )
            # APU  :  CL_TRUE CL_ADDRESS_MIRRORED_REPEAT CL_FILTER_NEAREST
            # BPU  :  CL_TRUE CL_ADDRESS_MIRRORED_REPEAT CL_FILTER_NEAREST
            # CPU  :  CL_TRUE CL_ADDRESS_MIRRORED_REPEAT CL_FILTER_NEAREST
            # DPU  :  CL_TRUE CL_ADDRESS_MIRRORED_REPEAT CL_FILTER_NEAREST
            # EPU  :  CL_TRUE CL_ADDRESS_MIRRORED_REPEAT CL_FILTER_NEAREST
            # FPU  :  CL_TRUE CL_ADDRESS_MIRRORED_REPEAT CL_FILTER_NEAREST
            # GPU  :  CL_TRUE CL_ADDRESS_MIRRORED_REPEAT CL_FILTER_NEAREST
            # HPU  :  CL_TRUE CL_ADDRESS_MIRRORED_REPEAT CL_FILTER_NEAREST
            # IPU  :  CL_TRUE CL_ADDRESS_MIRRORED_REPEAT CL_FILTER_NEAREST
            # JPU  :  CL_TRUE CL_ADDRESS_MIRRORED_REPEAT CL_FILTER_NEAREST
            # KPU  :  CL_TRUE CL_ADDRESS_MIRRORED_REPEAT CL_FILTER_NEAREST
            # LPU  :  CL_TRUE CL_ADDRESS_MIRRORED_REPEAT CL_FILTER_NEAREST
            # MPU  :  CL_TRUE CL_ADDRESS_MIRRORED_REPEAT CL_FILTER_NEAREST
            # NPU  :  CL_TRUE CL_ADDRESS_MIRRORED_REPEAT CL_FILTER_NEAREST
            # OPU  :  CL_TRUE CL_ADDRESS_MIRRORED_REPEAT CL_FILTER_NEAREST
            # PPU  :  CL_TRUE CL_ADDRESS_MIRRORED_REPEAT CL_FILTER_NEAREST
            # QPU  :  CL_TRUE CL_ADDRESS_MIRRORED_REPEAT CL_FILTER_NEAREST
            # RPU  :  CL_TRUE CL_ADDRESS_MIRRORED_REPEAT CL_FILTER_NEAREST
            # SPU  :  CL_TRUE CL_ADDRESS_MIRRORED_REPEAT CL_FILTER_NEAREST
            # TPU  :  CL_TRUE CL_ADDRESS_MIRRORED_REPEAT CL_FILTER_NEAREST
            # UPU  :  CL_TRUE CL_ADDRESS_MIRRORED_REPEAT CL_FILTER_NEAREST
            # VPU  :  CL_TRUE CL_ADDRESS_MIRRORED_REPEAT CL_FILTER_NEAREST
            # WPU  :  CL_TRUE CL_ADDRESS_MIRRORED_REPEAT CL_FILTER_NEAREST
            # XPU  :  CL_TRUE CL_ADDRESS_MIRRORED_REPEAT CL_FILTER_NEAREST
            # YPU  :  CL_TRUE CL_ADDRESS_MIRRORED_REPEAT CL_FILTER_NEAREST
            # ZPU  :  CL_TRUE CL_ADDRESS_MIRRORED_REPEAT CL_FILTER_NEAREST
            
    except:
        print('(Step 123Z/700) OF SAMPLER4XI5TEST *** FAILED TO CREATE SAMPLER for XI ', time4xi())             
                   
    # ---------------------------------------------------------------------------------------------
    # PHASE II: CLASS TESTS - SET SAMPLER CALLBACK WITH METHOD                           
    # ---------------------------------------------------------------------------------------------        
    print('(Step 124A/700) OF SAMPLER4XI5TEST - TRYING TO SET SAMPLER CALLBACK WITH METHOD OF OBJECT XI2XI: ', xi2xi) 
    # 
    try:
        task4callback2sampler = {} 
        for key2pu in keys2pu:
            task4callback2sampler [key2pu]  = {}
                                         
        response4callback = xi2xi.set2samplercallback(task4callback2sampler)                                  
        
        key2response = response4callback.keys()
        for key2response in sorted(keys2response):
            print(key2response, ' : ', response4callback [key2response] ['CALLBACK'])
            # APU  :  <function trace2sampler4apu at 0x0000000004358348>
            # BPU  :  <function trace2sampler4bpu at 0x00000000043A73C8>
            # CPU  :  <function trace2sampler4cpu at 0x00000000044061C8>
            # DPU  :  <function trace2sampler4dpu at 0x0000000004456F48>
            # EPU  :  <function trace2sampler4epu at 0x00000000044AFD48>
            # FPU  :  <function trace2sampler4fpu at 0x0000000004501B48>
            # GPU  :  <function trace2sampler4gpu at 0x000000000455F948>
            # HPU  :  <function trace2sampler4hpu at 0x00000000045B4748>
            # IPU  :  <function trace2sampler4ipu at 0x0000000004655548>
            # JPU  :  <function trace2sampler4jpu at 0x000000000469E348>
            # KPU  :  <function trace2sampler4kpu at 0x0000000004711148>
            # LPU  :  <function trace2sampler4lpu at 0x0000000004759EC8>
            # MPU  :  <function trace2sampler4mpu at 0x00000000047B8CC8>
            # NPU  :  <function trace2sampler4npu at 0x0000000004818AC8>
            # OPU  :  <function trace2sampler4opu at 0x00000000048748C8>
            # PPU  :  <function trace2sampler4ppu at 0x00000000048E46C8>
            # QPU  :  <function trace2sampler4qpu at 0x000000000493C4C8>
            # RPU  :  <function trace2sampler4rpu at 0x00000000049DD2C8>
            # SPU  :  <function trace2sampler4spu at 0x0000000004A270C8>
            # TPU  :  <function trace2sampler4tpu at 0x0000000004A56E48>
            # UPU  :  <function trace2sampler4upu at 0x0000000004AA5C48>
            # VPU  :  <function trace2sampler4vpu at 0x0000000004B0DA48>
            # WPU  :  <function trace2sampler4wpu at 0x0000000004BC8648>
            # XPU  :  <function trace2sampler4xpu at 0x0000000004B71848>
            # YPU  :  <function trace2sampler4ypu at 0x0000000004C3D448>
            # ZPU  :  <function trace2sampler4zpu at 0x0000000004C94248>
                          
    except:
        print('(Step 124Z/700) OF SAMPLER4XI5TEST *** FAILED TO SET SAMPLER CALLBACK WITH METHOD ***', time4xi())                  

                                                                                                      
    # ---------------------------------------------------------------------------------------------
    # PHASE II: CLASS TESTS - TRACE SAMPLERS                         
    # ---------------------------------------------------------------------------------------------    
    print('(Step 125A/25) OF SAMPLER4XI5TEST - TRYING TO TRACE XI: ', time4xi()) 
    try:                               
        task4trace2sampler  = {}
        for key2pu in keys2pu:
            task4trace2sampler[key2pu]  = {}
            
        response4trace2sampler = xi2xi.trace2sampler(task4trace2sampler) 
        
        key2response = response4trace2sampler.keys()
        for key2response in sorted(keys2response):
            print(key2response, ' : ', response4trace2sampler[key2response] )
            # APU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4apu-failed {}; time: 03:10:32 11/09/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4apu', 'METHOD': 'trace2sampler4apu'}
            # BPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4bpu-failed {}; time: 03:10:32 11/09/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4bpu', 'METHOD': 'trace2sampler4bpu'}
            # CPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4cpu-failed {}; time: 03:10:32 11/09/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4cpu', 'METHOD': 'trace2sampler4cpu'}
            # DPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4dpu-failed {}; time: 03:10:32 11/09/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4dpu', 'METHOD': 'trace2sampler4dpu'}
            # EPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4epu-failed {}; time: 03:10:32 11/09/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4epu', 'METHOD': 'trace2sampler4epu'}
            # FPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4fpu-failed {}; time: 03:10:32 11/09/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4fpu', 'METHOD': 'trace2sampler4fpu'}
            # GPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4gpu-failed {}; time: 03:10:32 11/09/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4gpu', 'METHOD': 'trace2sampler4gpu'}
            # HPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4hpu-failed {}; time: 03:10:32 11/09/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4hpu', 'METHOD': 'trace2sampler4hpu'}
            # IPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4ipu-failed {}; time: 03:10:32 11/09/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4ipu', 'METHOD': 'trace2sampler4ipu'}
            # JPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4jpu-failed {}; time: 03:10:32 11/09/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4jpu', 'METHOD': 'trace2sampler4jpu'}
            # KPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4kpu-failed {}; time: 03:10:32 11/09/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4kpu', 'METHOD': 'trace2sampler4kpu'}
            # LPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4lpu-failed {}; time: 03:10:32 11/09/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4lpu', 'METHOD': 'trace2sampler4lpu'}
            # MPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4mpu-failed {}; time: 03:10:32 11/09/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4mpu', 'METHOD': 'trace2sampler4mpu'}
            # NPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4npu-failed {}; time: 03:10:32 11/09/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4npu', 'METHOD': 'trace2sampler4npu'}
            # OPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4opu-failed {}; time: 03:10:32 11/09/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4opu', 'METHOD': 'trace2sampler4opu'}
            # PPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4ppu-failed {}; time: 03:10:32 11/09/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4ppu', 'METHOD': 'trace2sampler4ppu'}
            # QPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4qpu-failed {}; time: 03:10:32 11/09/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4qpu', 'METHOD': 'trace2sampler4qpu'}
            # RPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4rpu-failed {}; time: 03:10:32 11/09/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4rpu', 'METHOD': 'trace2sampler4rpu'}
            # SPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4spu-failed {}; time: 03:10:32 11/09/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4spu', 'METHOD': 'trace2sampler4spu'}
            # TPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4tpu-failed {}; time: 03:10:32 11/09/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4tpu', 'METHOD': 'trace2sampler4tpu'}
            # UPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4upu-failed {}; time: 03:10:32 11/09/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4upu', 'METHOD': 'trace2sampler4upu'}
            # VPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4vpu-failed {}; time: 03:10:32 11/09/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4vpu', 'METHOD': 'trace2sampler4vpu'}
            # WPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4wpu-failed {}; time: 03:10:32 11/09/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4wpu', 'METHOD': 'trace2sampler4wpu'}
            # XPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4xpu-failed {}; time: 03:10:32 11/09/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4xpu', 'METHOD': 'trace2sampler4xpu'}
            # YPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4ypu-failed {}; time: 03:10:32 11/09/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4ypu', 'METHOD': 'trace2sampler4ypu'}
            # ZPU  :  {'MESSAGE': '{(Step 2Z0/33) failed; trace2sampler4zpu-failed {}; time: 03:10:32 11/09/11 Pacific Standard Time}', 'CLASS': 'trace2sampler4zpu', 'METHOD': 'trace2sampler4zpu'}                                                                                                       
    except:
        print('(Step 125Z/25) OF SAMPLER4XI5TEST *** FAILED TO TRACE XI: ', time4xi())   
                                                                                                          
   
    # ---------------------------------------------------------------------------------------------
    # PHASE II: CLASS TESTS - RELEASE SAMPLER BY DECREMENTING REFERENCE COUNT WITH 1             
    # ---------------------------------------------------------------------------------------------    
    print('(Step 133A/700) OF SAMPLER4XI5TEST - TRYING TO RELEASE SAMPLERS OF XI DEVICE ', time4xi())    
    # 
    try: 
        task4release = {} 
        for key2pu in keys2pu:
            task4release [key2pu]  = {}
                
        response4release = xi2xi.release2sampler(task4release)
        
        key2response = response4release.keys()
        for key2response in keys2response:
            print(key2response, ' : ', response4release [key2response] ['COUNT2REFERENCE'])
            # DPU  :  0
            # EPU  :  0
            # BPU  :  0
            # CPU  :  0
            # VPU  :  0
            # RPU  :  0
            # WPU  :  0
            # SPU  :  0
            # PPU  :  0
            # QPU  :  0
            # KPU  :  0
            # YPU  :  0
            # LPU  :  0
            # ZPU  :  0
            # HPU  :  0
            # FPU  :  0
            # TPU  :  0
            # GPU  :  0
            # UPU  :  0
            # XPU  :  0
            # OPU  :  0
            # APU  :  0
            # MPU  :  0
            # IPU  :  0
            # NPU  :  0
            # JPU  :  0
    except:
        print('(Step 133Z1/700) OF SAMPLER4XI5TEST *** FAILED TO RELEASE SAMPLERS OF XI DEVICE ', time4xi())  
    

    print('(Step 133C/700) OF SAMPLER4XI5TEST - TRYING TO GET SELECTED SAMPLER INFO OF XI DEVICE ', time4xi())      
    # 
    try: 
        task4getinfo2sampler = {}
        for key2pu in keys2pu:
            task4getinfo2sampler [key2pu]  = {}
            task4getinfo2sampler [key2pu] ['NORMALIZATION']  = 'Yes'
            task4getinfo2sampler [key2pu] ['ADDRESSINGMODE']  = 'Yes'
            task4getinfo2sampler [key2pu] ['FILTERINGMODE']   = 'Yes'            
                                        
        response4getinfosampler = xi2xi.get2samplerinfo (task4getinfo2sampler)                                                                                             
        
        keys2response = response4getinfosampler.keys()
        for key2response in keys2response:
            print(key2response, ' : ', response4getinfosampler[key2response])
            # APU  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0 ...
            # ...
            # ZPU  :  {'CODE2ERROR': 0, 'COUNT2REFERENCE': 0 ...
    except:
        print('(Step 133Z2/700) OF SAMPLER4XI5TEST *** FAILED TO GET SELECTED SAMPLER INFO OF XI DEVICE ', time4xi())  
                               
    
    # ---------------------------------------------------------------------------------------------
    # PHASE II: CLASS TESTS - RETAIN SAMPLER BY DECREASING REFERENCE WITH 1             
    # ---------------------------------------------------------------------------------------------    
    print('(Step 134A/700) OF SAMPLER4XI5TEST - TRYING TO RETAIN SAMPLER OF XI DEVICE ', time4xi())   
    try:
        task4retain2sampler = {} 
        for key2pu in keys2pu:
            task4retain2sampler [key2pu]  = {}
            task4retain2sampler [key2pu] ['COUNT2REFERENCE'] = 1 

        response4retainsampler = xi2xi.retain2sampler(task4retain2sampler)                                                                                                 
                                
        keys2response = response4retainsampler.keys()
        for key2response in keys2response:
            print(key2response, ' : ', response4retainsampler[key2response] ['COUNT2REFERENCE'] )
            # DPU  :  1
            # EPU  :  1
            # BPU  :  1
            # CPU  :  1
            # VPU  :  1
            # RPU  :  1
            # WPU  :  1
            # SPU  :  1
            # PPU  :  1
            # QPU  :  1
            # KPU  :  1
            # YPU  :  1
            # LPU  :  1
            # ZPU  :  1
            # HPU  :  1
            # FPU  :  1
            # TPU  :  1
            # GPU  :  1
            # UPU  :  1
            # XPU  :  1
            # OPU  :  1
            # APU  :  1
            # MPU  :  1
            # IPU  :  1
            # NPU  :  1
            # JPU  :  1
    except:
        print('(Step 134Z1/700) OF SAMPLER4XI5TEST *** FAILED TO RETAIN SAMPLER OF XI DEVICE ', time4xi())

    print('(Step 134C/700) OF SAMPLER4XI5TEST - TRYING TO GET SELECTED SAMPLER INFO OF XI DEVICE ', time4xi())     
    # 
    try:                               
        task4getinfo2sampler = {} 
        for key2pu in keys2pu:
            task4getinfo2sampler [key2pu]  = {}
            task4getinfo2sampler [key2pu] ['NORMALIZATION']  = 'YES'
            task4getinfo2sampler [key2pu] ['ADDRESSINGMODE']  = 'YES'
            task4getinfo2sampler [key2pu] ['FILTERINGMODE']  = 'YES'            
                                
        response4getinfosampler = xi2xi.get2samplerinfo (task4getinfo2sampler)                                                                                             
        
        keys2response = response4getinfosampler.keys()
        for key2response in keys2response:
            print(key2response, ' : ', response4getinfosampler[key2response] ['NORMALIZATION'], response4getinfosampler[key2response] ['ADDRESSINGMODE'], response4getinfosampler[key2response] ['FILTERINGMODE'] )
            # DPU  :  CL_TRUE CL_ADDRESS_MIRRORED_REPEAT CL_FILTER_NEAREST
            # EPU  :  CL_TRUE CL_ADDRESS_MIRRORED_REPEAT CL_FILTER_NEAREST
            # BPU  :  CL_TRUE CL_ADDRESS_MIRRORED_REPEAT CL_FILTER_NEAREST
            # CPU  :  CL_TRUE CL_ADDRESS_MIRRORED_REPEAT CL_FILTER_NEAREST
            # VPU  :  CL_TRUE CL_ADDRESS_MIRRORED_REPEAT CL_FILTER_NEAREST
            # RPU  :  CL_TRUE CL_ADDRESS_MIRRORED_REPEAT CL_FILTER_NEAREST
            # WPU  :  CL_TRUE CL_ADDRESS_MIRRORED_REPEAT CL_FILTER_NEAREST
            # SPU  :  CL_TRUE CL_ADDRESS_MIRRORED_REPEAT CL_FILTER_NEAREST
            # PPU  :  CL_TRUE CL_ADDRESS_MIRRORED_REPEAT CL_FILTER_NEAREST
            # QPU  :  CL_TRUE CL_ADDRESS_MIRRORED_REPEAT CL_FILTER_NEAREST
            # KPU  :  CL_TRUE CL_ADDRESS_MIRRORED_REPEAT CL_FILTER_NEAREST
            # YPU  :  CL_TRUE CL_ADDRESS_MIRRORED_REPEAT CL_FILTER_NEAREST
            # LPU  :  CL_TRUE CL_ADDRESS_MIRRORED_REPEAT CL_FILTER_NEAREST
            # ZPU  :  CL_TRUE CL_ADDRESS_MIRRORED_REPEAT CL_FILTER_NEAREST
            # HPU  :  CL_TRUE CL_ADDRESS_MIRRORED_REPEAT CL_FILTER_NEAREST
            # FPU  :  CL_TRUE CL_ADDRESS_MIRRORED_REPEAT CL_FILTER_NEAREST
            # TPU  :  CL_TRUE CL_ADDRESS_MIRRORED_REPEAT CL_FILTER_NEAREST
            # GPU  :  CL_TRUE CL_ADDRESS_MIRRORED_REPEAT CL_FILTER_NEAREST
            # UPU  :  CL_TRUE CL_ADDRESS_MIRRORED_REPEAT CL_FILTER_NEAREST
            # XPU  :  CL_TRUE CL_ADDRESS_MIRRORED_REPEAT CL_FILTER_NEAREST
            # OPU  :  CL_TRUE CL_ADDRESS_MIRRORED_REPEAT CL_FILTER_NEAREST
            # APU  :  CL_TRUE CL_ADDRESS_MIRRORED_REPEAT CL_FILTER_NEAREST
            # MPU  :  CL_TRUE CL_ADDRESS_MIRRORED_REPEAT CL_FILTER_NEAREST
            # IPU  :  CL_TRUE CL_ADDRESS_MIRRORED_REPEAT CL_FILTER_NEAREST
            # NPU  :  CL_TRUE CL_ADDRESS_MIRRORED_REPEAT CL_FILTER_NEAREST
            # JPU  :  CL_TRUE CL_ADDRESS_MIRRORED_REPEAT CL_FILTER_NEAREST
            
    except:
        print('(Step 134Z2/700) OF SAMPLER4XI5TEST *** FAILED TO GET SELECTED SAMPLER INFO OF XI DEVICE ', time4xi())         
                                                        
    # ---------------------------------------------------------------------------------------------
    # PHASE II: CLASS TESTS - SENSE SAMPLER                           
    # ---------------------------------------------------------------------------------------------    
    print('(Step 170A/700) OF SAMPLER4XI5TEST - SENSING ', time4xi())  
    # 
    try:

        response4sense = xi2xi.sense()
        
        print(response4sense)
        # {'object': <sampler4xi.Sampler4Xi object at 0x00000000052FD1D0>, 'classvariable2xi-of-Sampler4Xi': 4}      

    except:
        print('(Step 170Z/700) OF SAMPLER4XI5TEST *** FAILED TO SENSE ', time4xi())          
        
    # ---------------------------------------------------------------------------------------------
    # PHASE II: CLASS TESTS - REASON SAMPLER                           
    # ---------------------------------------------------------------------------------------------    
    print('(Step 171A/700) OF SAMPLER4XI5TEST - REASONING ', time4xi())  
    # 
    try:
                
        response4reason = xi2xi.reason()
        
        print(response4reason)
        # {'object-reason-object4xi': <sampler4xi.Sampler4Xi object at 0x00000000052FD1D0>, 'time-reason-of-Sampler4Xi': '03:10:33 11/09/11 Pacific Standard Time'}        

    except:
        print('(Step 171Z/700) OF SAMPLER4XI5TEST *** FAILED TO REASON ', time4xi())                                  
             
    # ---------------------------------------------------------------------------------------------
    # PHASE II: CLASS TESTS - ACE SAMPLER                           
    # ---------------------------------------------------------------------------------------------    
    print('(Step 172A/700) OF SAMPLER4XI5TEST - ACING ', time4xi())  
    # 
    try:

        response4ace = xi2xi.ace()

        print(response4ace)
        # {'cores-of-Sampler4Xi': 4, 'object8xi': <sampler4xi.Sampler4Xi object at 0x00000000052FD1D0>}  

    except:
        print('(Step 172Z/700) OF SAMPLER4XI5TEST *** FAILED TO ACE ', time4xi())                                  
     
    # ---------------------------------------------------------------------------------------------
    # DONE - ALL TESTS                          
    # ---------------------------------------------------------------------------------------------    
    print('=' *33)          
    print('(Step 174/700) OF SAMPLER4XI5TEST - DONE! ', time4xi())
    # 03:10:33 11/09/11 Pacific Standard Time
                         
    print('=' *33) 
        

      
#</function4xi>            
    
# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
#   main function for sampler4xi5test
#"> 
# -------------------------------------------------------------------------------------------------    
def main():
    global trace2scope
    global trace_object_count    
    # --------------------------------------------------------------------------------------------- 
    # INITIALIZE TRACE
    # ---------------------------------------------------------------------------------------------        
    trace2scope = Print4Xi()
    set2trace4xi()                                                                                               # trace all classes and functions in the system
    deny2trace4xi()                                                                                              # deny trace for all classes and functions in the system
    tailor2trace4xi()                                                                                            # tailor trace for this test          
    print('=' *33)
    print("(Step 0A/700) OF SAMPLER4XI5TEST - SENSING IT WITH YOURDRAGONXI!", time4xi()) 
    # 
    print('=' *33)    
    try:     
    
        sampler4xi5test()  
    
        print('=' *33)
        print("(Step 0B/700) OF SAMPLER4XI5TEST - SENSED IT WITH YOURDRAGONXI!", time4xi()) 
        # 
        print('=' *33)
    except:
        pass
    finally:            
        # ---------------------------------------------------------------------------------------------    
        # Print Trace
        # ---------------------------------------------------------------------------------------------     
        print2trace4xi(trace2scope) 
#</function4xi>
     

# -------------------------------------------------------------------------------------------------
# __main__                              
# -------------------------------------------------------------------------------------------------
if __name__ == '__main__':
    main()
#</program4xi>
 

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
# sampler4xi5test.txt
# sense-sampler4xi5test.xml
# reason-sampler4xi5test.xml
# ace-sampler4xi5test.xml
#" 
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>


#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of sampler4xi5test.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/> 
